.intel_syntax noprefix
		
.data
n:	.byte	3		# Stepen broja 2 koji odredjuje duzinu vektora.
x_in:	.byte	0, 1, 2, 3, 4, 5, 6, 7	# Ulazni vektor.
format:	.asciz	"%d\n"		# Format za ispis elemenata izlaznog vektora.

.bss
.lcomm	x_out, 8		# Izlazni vektor.
			
.text
.global  main

main:
	## Prolog funkcije.
        enter   0, 0
        pusha

	## Tokom premetanja elemenata ulaznog vektora, registar esi ce drzati
	## adresu tekuceg elementa ulaznog vektora, a registar edi adresu
	## prvog elementa izlaznog vektora.
	cld
	lea	esi, x_in
	lea	edi, x_out

	## U registru edx ce se cuvati duzina gornjih vektora, koja se 
	## izracununava kao n-ti stepen broja 2. Registar ecx ce biti brojac
	## i kretace se od 0 do 2^n-1.
	mov	edx, 1
	mov	cl, [n]
	shl	edx, cl
	xor	ecx, ecx

shuffle_element:
	## Provjerava se da li je brojac dostigao 2^n i, ako jeste, zavrsava
	## se sa premetanjem.
	cmp	ecx, edx
	je print

	## Tekuci indeks ulaznog vektora se prebacuje u registar eax, dok ce
	## u registru ebx biti izracunat odgovarajuci indeks izlaznog vektora.
	mov	eax, ecx
	xor	ebx, ebx

	## U unutrasnjoj petlji ce bitovi indeksa ulaznog vektora biti 
	## procitani naopacke i na taj nacin ce biti formiran odgovarajuci
	## indeks izlaznog vektora. Registar ecx ce biti koriscen kao brojac i
	## u unutrasnoj petlji, s tim sto se njegov sadrzaj mora sacuvati.
	push	ecx
	xor	ecx, ecx
	mov	cl, [n]
	
next_bit:
	## U svakom koraku unutrasnje petlje pomjera se registar eax (tj. 
	## indeks ulaznog vektora) za jedan bit udesno, pri cemu se krajnje 
	## desni bit smjesta u carry bit. Zatim se pomjera registar ebx (tj. 
	## indeks izlaznog vektora) za jedan bit ulijevo, pri cemu se kao 
	## njegov krajnje desni bit uzima carry bit. Na ovaj nacin se po
	## zavrsetku ove petlje indeks ulaznog vektora dobija procitan 
	## naopacke u registru ebx.
	rcr	eax
	rcl	ebx
	loop next_bit

	## Vraca se vrijednost registra ecx kao brojaca u spoljasnjoj petlji.
	pop	ecx

	## Ucitava se tekuci bajt ulaznog vektora i premjesta na odgovarajucu
	## lokaciju u izlaznom vektoru.
	lodsb
	mov	[edi+ebx], al

	## Inkrementira se brojac unutrasnje petlje i nastavlja se sa istom.
	inc	ecx
	jmp shuffle_element

print:
	## Tokom stampanja ce registar esi drzati adresu tekuceg elementa 
	## izlaznog vektora, a registar ecx ce se koristiti kao brojac.
	## Elementi izlaznog vektora ce biti ucitavani u registar eax.
	lea	esi, x_out
	mov	ecx, edx
	xor	eax, eax
	
print_element:
	## Ucitava se i stampa tekuci element izlaznog vektora. Vazno je da se
	## pritom sacuva sadrzaj registra ecx koji se koristi kao brojac u 
	## petlji.
	lodsb
	push	ecx
	push	eax
	lea	eax, format
	push	eax
	call printf
	add	esp, 8
	pop	ecx
	loop print_element

finish:
	## Epilog funkcije.
	popa
	mov	eax, 0
	leave
	ret	
