.intel_syntax noprefix
	
.text
.global coeff

	## Funkcija coeff() izracunava binomni koeficijent. Argumenti
	## funkcije su:
	##   [ebp+8] - broj n
	##   [ebp+12] - broj k
	## Pretpostavka je da su dati brojevi pozitivni, kao i da je
	## n>=k. Funkcija vraca vrijednost izracunatog
	## koeficijenta. Funkcija se u potpunosti podvrgava C 
	## konvencijama pozivanja.
coeff:
        ## Prolog funkcije.
        enter	0, 0
	push	ebx

	## Vrijednost trazenog koeficijenta ce biti izracunata kao:
	##   (n*(n-1)*...*(n-k+1))/(k*(k-1)*...*1)
	## Prvo ce biti izracunata vrijednost brojica, pa ce se onda ta
	## vrijednost dijeliti sa svakim od elemenata imenioca.

	## U registru eax ce biti akumulirana vrijednost trazenog
	## koeficijenta.
	mov	eax, 1

	## U registar ebx se smjesta vrijednost n-k+1. Registar ecx se
	## inicijalizuje na n, a u petlji ce dobijati vrijednosti
	## n-1,...,n-k+1.
	mov	ebx, [ebp+8]
	sub	ebx, [ebp+12]
	mov	ecx, [ebp+8]

next_num_factor:
	## Racuna se vrijednost brojioca gornjeg izraza.
	cmp	ecx, ebx
	jbe denominator
	mul	ecx
	dec	ecx
	jmp next_num_factor

denominator:
	
	## Tokom uracunavanja elemenata iz imenioca gornjeg izraza,
	## registar ecx ce cuvati tekuci element.
	mov	ecx, [ebp+12]

next_den_factor:
	## Uracunavaju se elementi iz imenioca gornjeg
	## izraza. Napravljena je jedna sitna optimizacija, a to je da
	## je izbjegnuto dijeljenje sa 1 na kraju.
	cmp	ecx, 1
	jbe finish
	xor	edx, edx
	div	ecx
	dec	ecx
	jmp next_den_factor
	
finish:
	## Epilog funkcije.
	pop	ebx
        leave
        ret
