#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

/* Deklaracija funkcije atans(). */
extern void     atans(int n, float *table);

/* Deklaracija funkcije cordic(). */
extern void     cordic(float theta, int n, float *table, float *sin_theta, float *cos_theta);

int
main()
{
	const float     pi = 3.14159265358979323846;	/* Broj pi. */
	float           theta;	/* Ugao ciji se sinus i kosinus izracunavaju. */
	int             n;	/* Broj iteracija. */
	float          *table;	/* Tabela predracunatih inverznih tangensa. */
	float           sin_theta, cos_theta;	/* Sinus i kosinus datog
						 * ugla. */

	/* Ucitavaju se ugao i broj iteracija. */
	scanf("%f", &theta);
	assert(-pi / 2 < theta && theta < pi / 2);
	scanf("%d", &n);
	assert(n > 0);

	/* Alocira se memorija za tabelu inverznih tangensa. */
	table = (float *)malloc(n * sizeof(float));
	assert(table != NULL);

	/* Formira se tabela inverznih tangensa. */
	atans(n, table);

	/* Izracunavaju se i stampaju sinus i kosinus datog ugla. */
	cordic(theta, n, table, &sin_theta, &cos_theta);
	printf("%g %g\n", sin_theta, cos_theta);

	/* Oslobadja se memorija koju je zauzimala tabela inverznih tangensa. */
	free(table);

	return 0;
}
