.intel_syntax noprefix
                
.text
.global runaround

        ## Funkcija runaround() ispituje da li dati broj zadovoljava
	## runaround svojstvo.  Argumenti funkcije su:
        ##   [ebp+8] - string koji predstavlja broj koji se ispituje
        ## Pretpostavlja se da su svi karakteri datog stringa decimalne
	## cifre razlicite od 0.  Funkcija vraca 1 ako u pitanju jeste
	## runaround broj, 0 u suprotnom. Funkcija se u potpunosti
	## podvrgava C konvencijama pozivanja.
runaround:
        ## Prolog funkcije.
        enter   0, 0
        push    ebx
        push    esi
        push    edi

        ## Inicijalizuje se direction flag.
        cld

        ## Izracunava se duzina stringa.  Ako je u pitanju prazan
        ## string, odmah se zavrsava funkcija.  U suprotnom, duzina
	## stringa se cuva u registru ebx.
        xor     eax, eax
        mov     edi, [ebp+8]
        mov     ecx, -1
        repnz scasb
        add     ecx, 2
        neg     ecx
        jecxz false
        mov     ebx, ecx

        ## Registar esi ce cuvati adresu prvog karaktera stringa.
        ## Registar ecx ce brojati koliko cifara je procesirano.
        ## Registar eax ce sadrzati indeks tekuce cifre.
        mov     esi, [ebp+8]
        xor     ecx, ecx
        xor     eax, eax

next_digit:
        ## Ocitava se tekuca cifra i odredjuje se indeks naredne cifre,
	## tako sto se na indeks tekuce cifre doda sama tekuca cifra, a
        ## potom se odredi ostatak pri dijeljenju ovako dobijenog broja
	## sa duzinom stringa.
        add     al, [esi+eax]
        sub     al, '0'
        cdq
        div     ebx
        mov     eax, edx

        ## Uvecava se broj procesiranih cifara i provjerava se da li je
	## taj broj jednak duzini stringa, u kom slucaju se prekida
	## petlja.
        inc     ecx
        cmp     ecx, ebx
        jb next_digit

        ## Provjerava se da li je finalni indeks naredne cifre jednak
        ## indeksu prve cifre u stringu.  Ako je to slucaj, u pitanju
	## jeste runaround broj, u suprotnom nije u pitanju takav broj.
        cmp     eax, 0
        jne false

        ## Vraca se 1 kao rezultat funckcije.
        mov     eax, 1
        jmp finish

false:
        ## Vraca se 0 kao rezultat funckcije.
        xor     eax, eax

finish:         
        ## Epilog funkcije.
        pop     edi
        pop     esi
        pop     ebx
        leave
        ret
