.intel_syntax noprefix

.text
.global most_frequent_letter
        
        ## Funkcija most_frequent_letter() odredjuje slovo koje se
        ## najcesce pojavljuje u datom tekstu.  Argumenti funkcije su:
        ##   [ebp+8] - adresa prvog karaktera u datom tekstu
        ##   [ebp+12] - duzina teksta
        ## Pretpostavlja se da je duzina teksta nenegativan
        ## broj. Funkcija se u potpunosti podvrgava C konvencijama
	## pozivanja.
most_frequent_letter:
        ## Prolog funkcije.
        enter   104, 0
        push    esi
        push    edi

        ## Incijalizuje se direction fleg.
        cld

        ## Inicijalizuje se broj pojavljivanja svakog slova u polju
        ## koje je alocirano kao lokalna promjenljiva.  Registar edi se
        ## ovdje koristi kao adresa tekuceg elementa polja, a registar
	## ecx kao brojac u petlji.
        lea     edi, [ebp-104]
        mov     ecx, 26
        xor     eax, eax
        rep stosd

        ## Izracunava se broj pojavljivanja svakog slova u datom
        ## tekstu.  Registar esi se ovdje koristi kao adresa tekuceg 
        ## karaktera, a registar ecx kao brojac u petlji.
        mov     esi, [ebp+8]
        mov     ecx, [ebp+12]
next_character:
        ## Ucitava se naredni karakter.
        lodsb

        ## Ako je u pitanju veliko slovo, inkrementira se odgovarajuci
	## broj pojavljivanja.
        cmp     al, 'A'
        jb lowercase
        cmp     al, 'Z'
        ja lowercase
        sub     al, 'A'
        inc     dword ptr [ebp+4*eax-104]
        jmp continue

lowercase:
        ## Ako je u pitanju malo slovo, takodje se inkrementira
	## odgovarajuci broj pojavljivanja.
        cmp     al, 'a'
        jb continue
        cmp     al, 'z'
        ja continue
        sub     al, 'a'
        inc     dword ptr [ebp+4*eax-104]

continue:             
        ## Prelazi se na naredni karakter.
        loop next_character

        ## Odredjuje se koje slovo se najcesce pojavljuje u datom
        ## tekstu.  Registar eax ovdje sadrzi indeks tekuceg slova,
        ## registar edx broj pojavljivanja slova koje se najcesce
	## pojavljivalo, a registar ecx indeks toga slova.
        xor     eax, eax
        mov     edx, [ebp+4*eax-104]
        mov     ecx, eax
next_letter:
        ## Inkrementira se indeks tekuceg slova i provjerava se da li se
	## proslo kroz sva slova.
        inc     eax
        cmp     eax, 26
        jae finalize

        ## Poredi se broj pojavljivanja slova sa najvise pojavljivanja
        ## dosad sa brojem pojavljivanja tekuceg slova i ukoliko se
        ## tekuce slovo nije pojavljivalo vise puta prelazi se na
	## naredno slovo.
        cmp     edx, [ebp+4*eax-104]
        jae next_letter

        ## Ukoliko se pak tekuce slovo pojavljivalo dosad najvise puta,
        ## azuriraju se indeks slova sa najvise pojavljivanja, kao i
	## odgovarajuci broj pojavljivanja.
        mov     ecx, eax
        mov     edx, [ebp+4*eax-104]
        jmp next_letter

finalize:
        ## U registru eax se ostavlja ASCII kod slova sa najvecim brojem
	## pojavljivanja.
        add     ecx, 'A'
        mov     eax, ecx
        
        ## Epilog funkcije.
        pop     edi
        pop     esi
        leave
        ret
