#include <assert.h>
#include <stdio.h>

/* Deklaracija funkcije gauss_jordan(). */
extern void     gauss_jordan(float *A, float *b, float *x);

int
main()
{
	float           A[3][3];	/* Matrica koeficijenata lijeve
					 * strane datog sistema jednacina. 
					 */
	float           b[3];	/* Vektor koeficijenata desne strane datog 
				 * sistema jednacina. */
	float           x[3];	/* Vektor rjesenja datog sistema. */
	int             i;	/* Brojac u petljama. */

	/* Ucitavaju se koeficijenti datog sistema jednacina i provjerava
	 * se da sistem ima tacno jedno rjesenje. */
	for (i = 0; i < 3; i++)
		scanf("%f%f%f%f", &A[i][0], &A[i][1], &A[i][2], &b[i]);
	assert(A[0][0] * (A[1][1] * A[2][2] - A[1][2] * A[2][1]) -
	       A[0][1] * (A[1][0] * A[2][2] - A[1][2] * A[2][0]) +
	       A[0][2] * (A[1][0] * A[2][1] - A[1][1] * A[2][0]) != 0);

	/* Odredjuju se rjesenja sistema (pri pozivanju funkcije se
	 * koristi cinjenica da se elementi staticki alociranog
	 * dvodimenzionalnog polja redjaju u memoriji jedan iza drugog, po 
	 * redovima pocev od prvog reda). */
	gauss_jordan((float *) A, b, x);

	/* Stampaju se dobijeni rezultati. */
	for (i = 0; i < 3; i++)
		printf("%g\n", x[i]);

	return 0;
}
