.intel_syntax noprefix
			
.text
.global count

	## Funkcija count() prebrojava karaktere, rijeci i linije u
	## datom stringu. Argumenti funkcije su:
        ##   [ebp+8] - string nad kojim se vrsi prebrojavanje
	##   [ebp+12] - pointer na koji treba upisati broj karaktera
	##   [ebp+16] - pointer na koji treba upisati broj rijeci
	##   [ebp+20] - pointer na koji treba upisati broj linija
        ## Funkcija se u potpunosti podvrgava C konvencijama pozivanja.
count:
	## Prolog funkcije.
        enter   0, 0
	push	ebx
	push	esi
	push	edi

	## Registar esi ce sadrzati adresu tekuceg karaktera. Kroz
	## string ce se prolaziti od prvog karaktera prema zadnjem.
	cld
	mov	esi, [ebp+8]

	## Registri ebx, ecx i edx ce respektivno cuvati broj karaktera,
	## rijeci i linija u datom stringu. Ovi brojaci se inicijalizuju
	## na 0.
	xor	ebx, ebx
	xor	ecx, ecx
	xor	edx, edx

	## Registar edi ce biti koriscen kao fleg koji ce odredjivati da
	## li se trenutno nalazimo unutar neke rijeci ili ne.
	mov	edi, 0

next_char:
	## Ucitava se naredni karakter.
	lodsb

	## Provjerava se da li se doslo do kraja stringa i ako jeste
	## izlazi se iz petlje.
	cmp	al, 0
	je finish

	## Inkrementira se brojac karaktera.
	inc	ebx

	## Provjerava se da li je tekuci karakter neki od karaktera koji
	## razdvajaju rijeci i ako jeste skace se na odgovarajucu
	## labelu.
	cmp	al, ' '
	je space
	cmp	al, '\t'
	je space
	cmp	al, '\n'
	je newline

	## Ako je u pitanju obican karakter, provjerava se da li se
	## ispred njega nalazimo izvan rijeci i ako je to slucaj
	## inkrementira se brojac rijeci i naznacava se flegom u
	## registru edi da se sada nalazimo unutar rijeci.
	cmp	edi, 1
	je next_char
	inc	ecx
	mov	edi, 1
	jmp next_char

newline:
	## Ako je tekuci karakter znak za novu liniju, inkrementira se
	## brojac linija.
	inc	edx

space: 
	## Ako je tekuci karakter neki od blanko znakova, naznacava se
	## flegom u registru edi da se sada nalazimo izvan rijeci.
	mov	edi, 0

	## Prelazi se na sledeci karakter.
	jmp next_char

finish:
	## Upisuju se vrijednosti brojaca u lokacije na koje pokazuju
	## odgovarajuci pointeri.
	mov	eax, [ebp+12]
	mov	[eax], ebx
	mov	eax, [ebp+16]
	mov	[eax], ecx
	mov	eax, [ebp+20]
	mov	[eax], edx
	
	## Epilog funkcije.
	pop	edi
	pop	esi
	pop	ebx
	leave
	ret	
