.intel_syntax noprefix
                
.text
.global bubble_sort
        ## Funkcija bubble_sort() vrsi sortiranje niza stringova
	## koriscenjem bubble-sort metode.  Argumenti funkcije su:
        ##   [ebp+8] - duzina niza stringova
        ##   [ebp+12] - adresa prvog stringa u nizu
        ## Pretpostavlja se da je duzina niza stringova veca od
	## 0. Funkcija se u potpunosti podvrgava C konvencijama pozivanja.
bubble_sort:
        ## Prolog funkcije.
        enter   0, 0
        push    ebx
        push    esi
        push    edi

        ## Sve operacije nad stringovima ce biti izvodjenje pocev od
	## prvog elementa stringa prema krajnjem.
        clc

        ## Duzina niza ce biti cuvana u registru ebx.
        mov     ebx, [ebp+12]

        ## Registar ecx se u spoljasnjoj petlji koristi kao brojac
	## prolaza kroz pefikse datog niza.
        mov     ecx, [ebp+8]
        jecxz finish
pass_next:
        ## Registar edx se u unutrasnjoj petlji koristi kao indeks
	## narednog elementa niza.
        xor     edx, edx
        
pair_next:
        ## Na pocetku unutrasnje petlje se prvo provjerava da li je
        ## prolaz kroz pefiks niza zavrsen i, ako je to slucaj, prelazi
	## se na narednu iteraciju spoljasnje petlje.
        inc     edx
        cmp     edx, ecx
        jae pass_done

        ## Registar esi ce cuvati adresu prvog karaktera tekuceg, a
	## registar edi prvog karaktera narednog stringa.
        mov     esi, [ebx+4*edx-4]
        mov     edi, [ebx+4*edx]

        ## Registar ecx ce se u unutrasnjoj petlji cuvati duzinu drugog
	## stringa uvecanu za 1 (za terminirajuci karakter).
        push    ecx

        ## Odredjuje se duzina drugog stringa uvecana za 1.
        push    edi
        xor     eax, eax
        mov     ecx, -1
        repnz scasb
        inc     ecx
        neg     ecx
        pop     edi

        ## Porede se stringovi i ukoliko tekuci string nije u
        ## leksikografskom poretku veci od narednog stringa, prelazi se
	## na sledecu iteraciju u unutrasnjoj petlji.
        repz cmpsb
        jbe pair_done

        ## U suprotnom se mijenjaju mjesta tekuceg i narednog stringa u
	## nizu.
        mov     eax, [ebx+4*edx-4]
        xchg    eax, [ebx+4*edx]
        mov     [ebx+4*edx-4], eax

pair_done: 
        ## Nastavlja se sa iducim parom stringova.
        pop     ecx
        jmp pair_next

pass_done:
        ## Nastavlja se sa sledecim prefiksom niza.
        loop pass_next

finish:        
        ## Epilog funkcije.
        pop     edi
        pop     esi
        pop     ebx
        leave
        ret
