#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Maksimalna duzina linije. */
#define MAX_LENGTH 80

/* Deklaracija funkcije bubble_sort(). */
extern void     bubble_sort(int n, char **strings);

int
main()
{
	char            line[MAX_LENGTH + 1];	/* Linija ucitana sa
						 * standardnog ulaza. */
	int             length;	/* Duzina gornje linije. */
	int             n;	/* Duzina niza stringova. */
	char          **strings;	/* Niz stringova koji se
					 * sortiraju. */
	int             i;	/* Brojac u petljama. */

	/* Ucitavaju se broj stringova sa standardnog ulaza. */
	assert(fgets(line, MAX_LENGTH + 1, stdin) != NULL);
	sscanf(line, "%d", &n);
	assert(n > 0);

	/* Alocira se memorija i ucitavaju pojedinacni stringovi sa
	 * standardnog ulaza. */
	strings = (char **) malloc(n * sizeof(char *));
	assert(strings != NULL);
	for (i = 0; i < n; i++) {
		assert(fgets(line, MAX_LENGTH + 1, stdin) != NULL);
		if ((length = strlen(line)) > 0
		    && line[length - 1] == '\n')
			line[length - 1] = 0;
		strings[i] = (char *) malloc((length + 1) * sizeof(char));
		assert(strings[i] != NULL);
		strcpy(strings[i], line);
	}

	/* Vrsi se sortiranje niza stringova. */
	bubble_sort(n, strings);

	/* Stampaju se sortirani stringovi na standardni izlaz. */
	for (i = 0; i < n; i++)
		printf("%s\n", strings[i]);

	/* Oslobadja se memorija koriscena za stringove. */
	for (i = 0; i < n; i++)
		free(strings[i]);
	free(strings);

	return 0;
}
