.intel_syntax noprefix

.data
table:  .ascii "YXZXYYZYX"      # Tabela rezultujucih cestica, data po
                        	# redovima, pri cemu prvi red
                                # odn. kolona odgovaraju cestici X,
                                # drugi red odn. kolona cestici Y, a
                                # treci red odn. kolona cestici Z; svaki
                                # element tabele predstavlja rezultujucu
                        	# cesticu sekvence od dvije cestice, pri
                                # cemu je prva cestica u sekvenci
                                # odredjena redom, a druga kolonom
                        	# tabele.

.text
.global particles

       	## Funkcija particles() odredjuje rezultujucu cesticu u sekvenci
	## interakcija izmedju cestica iz datog niza. Argumenti funkcije
	## su:
        ##   [ebp+8] - adresa prvog u nizu karaktera koji predstavljaju
	##             cestice
        ## Pretpostavka je da dati niz sadrzi bar jedan karakter, kao i
	## da su karakteri koji ga sacinjavaju iskljucivo 'X', 'Y' i
	## 'Z'; rezultat funkcije je karakter koji predstavlja rezultujucu
        ## cesticu.  Funkcija se u potpunosti podvrgava C konvencijama
	## pozivanja.
particles:
        ## Prolog funkcije.
        enter   0, 0
        push    ebx
        push    esi

        ## Inicijalizuje se direction fleg.
        cld
      
        ## Ucitava se karakter koji predstavlja prvu cesticu u registar
        ## bl - ovaj registar ce uvijek sadrzati tekuci rezultat
	## sekvence interakcija. Registar esi ce sadrzati adresu na kojoj
        ## se nalazi karakter koji predstavlja tekucu cesticu.  Registar
	## cl ce sadrzati broj 3, koji je potreban za mnozenje.
        mov     esi, [ebp+8]
        lodsb
        mov     bl, al
        mov     cl, 3
        
next_particle:
        ## Izracunava se indeks reda za tekucu interakciju u tabeli
        ## rezultujucih cestica, i mnozi isti sa 3, a onda se
	## rezultat ovog mnozenja smjesta u registar edx.
        mov     al, bl
        sub     al, 'X'
        mul     cl
        xor     edx, edx
        mov     dl, al

        ## Ucitava se karakter koji predstavlja tekucu cesticu.  Ukoliko
	## se doslo do kraja stringa, zavrsava se sa iteracijom, a
        ## suprotnom se na osnovu tekuceg karaktera izracunava indeks
        ## kolone za tekucu interakciju u tabeli rezultujucih cestica.
        ## Ovaj indeks se dodaje na proizvod indeksa odgovarajuceg reda
        ## sa brojem 3, cime se u registru edx dobija indeks elementa
	## tabele na kome se nalazi rezultujuca cestica za tekucu
	## interakciju.
        lodsb
        cmp     al, 0
        je done
        sub     al, 'X'
        add     dl, al

        ## Ucitava se karakter koji predstavlja rezultujucu cesticu za
	## tekucu interakciju.
        mov     bl, [table+edx]

        ## Prelazi se na procesiranje naredne cestice u sekvenci.
        jmp next_particle

done:
        ## Prebacuje se finalni rezultat interakcije u registar eax.
        xor     eax, eax
        mov     al, bl

        ## Epilog funkcije.
        pop     esi
        pop     ebx
        leave
        ret
