#include <assert.h>
#include <stdio.h>
#include <stdlib.h>

/* Deskriptivna imena za indekse koordinata tacaka. */
#define X 0
#define Y 1
#define Z 2

/* Deklaracija funkcije intersection(). */
extern int      intersection(int n, float *C, float *a, float *lo,
			     float *hi);

int
main(void)
{
	int             n;	/* Broj zadatih kocki. */
	float          *C;	/* Polje sa koordinatama osnovnih tjemena
				 * kocki. */
	float          *a;	/* Polje sa duzinom stranica kocki. */
	float           lo[3],
	                hi[3];	/* Naspramna tjemena pravougaonog
				 * paralelopipeda koji predstavlja presjek 
				 * datih kocki. */
	int             i;	/* Brojac u petljama. */

	/* Ucitava se broj kocki, a zatim se alocira memorija za podatke o 
	 * kockama. */
	scanf("%d", &n);
	assert(n > 0);
	C = malloc(3 * n * sizeof(float));
	assert(C != NULL);
	a = malloc(n * sizeof(float));
	assert(a != NULL);

	/* Ucitavaju se podaci o kockama. */
	for (i = 0; i < n; ++i) {
		scanf("%f%f%f%f", &C[3 * i + X], &C[3 * i + Y],
		      &C[3 * i + Z], &a[i]);
		assert(a > 0);
	}

	/* Izracunava se, i eventualno stampa, presjek datih kocki. */
	if (intersection(n, C, a, lo, hi))
		printf("%g %g %g %g %g %g\n", lo[X], lo[Y], lo[Z], hi[X],
		       hi[Y], hi[Z]);

	/* Oslobadja se memorija koriscena za podatke o kockama. */
	free(C);
	free(a);

	return 0;
}
