.intel_syntax noprefix

.data
ten:    .int    10              # Broj 10.
        
.text
.global count

       	## Funkcija count() prebrojava koliko ima brojeva-palindroma u
	## intervalu od broja 1 do datog broja.  Argumenti funkcije su:
        ##   [ebp+8] - desna granica intervala koji se pretrazuje
        ## Funkcija vraca trazeni broj brojeva-palindroma.  Pretpostavka
	## je da je data desna granica intervala pozitivan broj.  Funkcija
	## se u potpunosti podvrgava C konvencijama pozivanja.
count:
        ## Prolog funkcije.
        enter   0, 0
        push    ebx
        push    esi
        push    edi

        ## Registar ecx ce biti koriscen kao brojac kroz dati interval,
        ## a registar ebx ce sadrzati broj pronadjenih
	## brojeva-palindroma.
        mov     ecx, [ebp+8]
        xor     ebx, ebx
        
next_number:
        ## Prebacuje se tekuci broj (za koga se ispituje da li je
        ## broj-palindrom) u registar eax; registar esi ce sadrzati
	## vrijednost toga broja sa obrnutim ciframa.
        mov     eax, ecx
        xor     esi, esi
        
next_digit:
        ## Izdvaja se tekuca cifra iz datog broja.
        xor     edx, edx
        div     dword ptr ten

        ## Prebacuju se tekuca cifra u registar edi, a preostale cifre
        ## broja u registar esi, iz koga se opet tekuca vrijednost
	## obrnutog broja dovodi u registar eax.
        mov     edi, edx        
        xchg    eax, esi

        ## Zaracunava se tekuca cifra u tekucu vrijednost obrnutog
	## broja.
        mul     dword ptr ten
        add     eax, edi

        ## Vracaju se preostale cifre datog broja u registar eax, a
	## tekuca vrijednost obrnutog broja u registar esi.
        xchg    eax, esi

        ## Provjerava se da li su procesirane sve cifre tekuceg broja.
        cmp     eax, 0
        ja next_digit

        ## Poredi se tekuci broj sa obrnutim brojem i, ako su jednaki,
	## inkrementira se brojac brojeva-palindroma.
        cmp     ecx, esi
        jne continue
        inc     ebx
        
continue:
        ## Prelazi se na naredni broj iz datog intervala.
        loop next_number

        ## Prebacuje se rezultat u registar eax.
        mov     eax, ebx

        ## Epilog funkcije.
        pop     edi
        pop     esi
        pop     ebx
        leave
        ret
