.intel_syntax noprefix
		
.data
n:	.int	-30		# Broj koji treba predstaviti datim ciframa.
digits:	.int	3,4,5,6,7	# Cifre koje ulaze u sastav izraza.
format:	.asciz  "%c"		# Format za ispis izraza.

.text
.global  main

main:
	## Prolog funkcije.
        enter   0, 0
        pusha

	## Izracunavanje izraza se vrsi od poslednje cifre prema prvoj.
	std

	## Sekvenca operatora bice kodirana 8-bitnim brojem, pri cemu svaka 2
	## bita predstavljaju jedan operator. Prema tome, da bi se presle sve
	## kombinacije operatora, treba proci kroz sve 8-bitne brojeve. Uzeto
	## je da je kod za sabiranje 11, za oduzimanje 10, za mnozenje 01 i za
	## dijeljenje 00. Registar ecx drzi kod tekuce kombinacije operatora.
	mov	ecx, 255

next_combination:
	## Registar esi se pozicionira na adresu poslednje cifre i ta cifra
	## se ucitava u registar edi. Registar edi ce drzati rezultat prilikom
	## izracunavanja izraza.
	lea	esi, digits
	add	esi, 16
	lodsd
	mov	edi, eax

	## Sadrzaj registra ecx se cuva na steku i takodje prebacuje u registar
	## ebx, iz koga ce biti ocitavan tekuci operator.
	push	ecx
	mov	ebx, ecx
	mov	ecx, 4

next_operation:
	## Za svaki operator, uzima se naredni operand,...
	lodsd

	## ...odredjuje se koji je operator u pitanju,...
	mov	edx, ebx
	and	edx, 3
	cmp	edx, 0
	je do_division
	cmp	edx, 1
	je do_multiplication
	cmp	edx, 2
	je do_subtraction

	## ...obavlja se odgovarajuca aritmeticka operacija (pri cemu se za
	## dijeljenje vodi racuna o slucajevima kada je djelilac jednak 0) i
	## rezultat smjesta natrag u registar edi...
do_addition:
	add	edi, eax
	jmp done

do_subtraction:
	sub	eax, edi
	mov	edi, eax
	jmp done

do_multiplication:
	imul	edi, eax
	jmp done

do_division:
	cmp	edi, 0
	je done
	cdq
	idiv	edi
	mov	edi, eax
	
done:
	## ...i na kraju se pomjera registar ebx za 2 mjesta udesno kako bi
	## na poslednja 2 bita dosao kod narednog operatora.
	shr	ebx, 2
	loop next_operation

	## Kada se izracuna izraz za datu kombinaciju operatora, provjerava se
	## da li je rezultat jednak zadatom broju. Ukoliko je to slucaj, skace
	## se na stampanje tekuce kombinacije operatora, a u suprotnom se 
	## prelazi na narednu kombinaciju.
	pop	ecx
	cmp	edi, [n]
	je print_operators
	loop next_combination

	## Ukoliko su sve kombinacije isprobane, znaci da se se dati broj ne
	## moze dobiti pomocu datih cifara i program se zavrsava.
	jmp finish

print_operators:
	## Slicno kao kod racunanja izraza, kod koji predstavlja kombinaciju
	## operatora se prebacuje u registar ebx odakle ce biti izdvajan jedan
	## po jedan operator.
	mov	ebx, ecx
	mov	ecx, 4

next_operator:
	## Za svaki operator, na osnovu koda operatora koji se izdvaja iz dva 
	## poslednja bita registra ebx odredjuje se koji je operator u 
	## pitanju,...
	xor	eax, eax
	mov	edx, ebx
	and	edx, 3
	cmp	edx, 0
	je print_division
	cmp	edx, 1
	je print_multiplication
	cmp	edx, 2
	je print_subtraction

	## ...potom se smjesta ASCII kod operatora u registar eax...
print_addition:
	mov	al, '+'
	jmp do_print

print_subtraction:
	mov	al, '-'
	jmp do_print

print_multiplication:	
	mov	al, '*'
	jmp do_print
	
print_division:
	mov	al, '/'

do_print:
	## ...i stampa se operator...
	push	ecx
	push	eax
	lea	eax, format
	push	eax
	call printf
	add	esp, 8
	pop	ecx

	## ...da bi se potom registar ebx siftovao za dva mjesta udesno kako
	## bi kod narednog operatora dosao na zadnja dva bita ovog registra.
	shr	ebx, 2
	loop next_operator

	## Na kraju se stampa oznaka za kraj reda.
	xor	eax, eax
	mov	al, '\n'
	push	eax
	lea	eax, format
	push	eax
	call printf
	add	esp, 8
	
finish:
	## Epilog funkcije.
	popa
	mov	eax, 0
	leave
	ret	
