.intel_syntax noprefix
		
.data
string:	.asciz	"abcbcddd"	# Dati string.
format: .asciz  "%c\n"		# Format za ispis rezultata.
		
.text
.global  main

main:
	## Prolog funkcije.
        enter   0, 0
        pusha

	## Za ispitivanje da li string odgovara datom regularnom izrazu bice
	## konstruisan konacni automat. Pored inicijalnog i finalnog stanja,
	## stanja koja se mogu uociti u datom regularnom izrazu su: stanje
	## nakon sto je uocen karakter 'a' (oznaceno sa stage1), stanje nakon
	## sto je uocen karakter 'b' ili 'c' (oznaceno sa stage2) i stanje
	## nakon sto je uocen karakter 'd' (oznaceno sa stage3). Za svako od
	## ovih stanja se uzima naredni karakter iz stringa i sprovodi
	## odgovarajuca tranzicija.

	## Registar esi ce prilikom uparivanja stringa sa regularnim izrazom 
	## pokazivati na tekuci karakter. Kroz string se prolazi pocev od prvog
	## karaktera pa prema poslednjem.
	cld
	lea	esi, string

	## Ucitava se prvi karakter i prelazi se u odgovarajuce stanje.
	lodsb
	cmp	al, 'a'
	je stage1
	cmp	al, 'b'
	je stage2
	cmp	al, 'c'
	je stage2
	jmp error

stage1:
	## Ucitava se naredni karakter i prelazi se u odgovarajuce stanje.
	lodsb
	cmp	al, 'b'
	je stage2
	cmp	al, 'c'
	je stage2
	jmp error

stage2:
	## Ucitava se naredni karakter i prelazi se u odgovarajuce stanje.
	lodsb
	cmp	al, 'b'
	je stage2
	cmp	al, 'c'
	je stage2
	cmp	al, 'd'
	je stage3
	cmp	al, 0
	je ok
	jmp error

stage3:
	## Ucitava se naredni karakter i prelazi se u odgovarajuce stanje.
	lodsb
	cmp	al, 'd'
	je stage3
	cmp	al, 0
	je ok
	jmp error

error:
	## Priprema se karakter 'n' za stampanje.
	xor	eax, eax
	mov	al, 'n'
	jmp print

ok:
	## Priprema se karakter 'y' za stampanje.
	xor	eax, eax
	mov	al, 'y'
	jmp print

print:
	## Stampa se rezultat uparivanja.
	push	eax
	lea	eax, format
	push	eax
	call printf
	add	esp, 8

finish:
	## Epilog funkcije.
	popa
	mov	eax, 0
	leave
	ret	
