.intel_syntax noprefix
		
.data
n:	.int	3		# Broj nula polinoma.
zeroes:	.int	1, 2, 3		# Nule polinoma.
format:	.asciz  "%d\n"		# Format za ispis koeficijenata polinoma.

.bss
.lcomm  coeffs, 16              # Polje sa koeficijentima polinoma.
	
.text
.global  main

main:
	## Prolog funkcije.
        enter   0, 0
        pusha

	## Inicijalizuje se polje sa koeficijentima polinoma tako sto se
	## svi elementi postave na 0, osim slobodnog clana koji se postavi na
	## 1. U registru edi se drzi adresa tekuceg koeficijenta, a registar
	## ecx se koristi kao brojac.
	cld
	lea	edi, coeffs

	## Upisuje se vrijednost 1 za slobodni clan.
	mov	eax, 1
	stosd

	## Upisuje se vrijednost 0 za ostale koeficijente.
	xor	eax, eax
	mov	ecx, [n]
	rep stosd

	## U glavnoj petlji programa mnozi se polinom predstavljen tekucim
	## vrijednostima koeficijenata sa termom x-z gdje je z tekuca nula.
	## U registru ecx se cuva indeks ove petlje kojim se prolazi kroz nule
	## polinoma, dok se u registru esi drzi adresa tekuce nule.
	xor	ecx, ecx
	lea	esi, zeroes

next_zero:
	## Provjerava se uslov izlaska iz petlje.
	cmp	ecx, [n]
	jge print

	## Inkrementira se indeks petlje, a potom se negirana vrijednost tekuce
	## nule polinoma upisuje u registar ebx.
	inc	ecx
	lodsd
	neg	eax
	mov	ebx, eax

	## U unutrasnjoj petlji se racunaju koeficijenti proizvoda polinoma
	## odredjenog tekucim vrijednostima koefijenata sa termom x-z.
	## Izracunavanje se sprovodi od koeficijenta uz najveci stepen
	## takvog proizvoda prema njegovom slobodnom clanu. U registru ecx
	## se drzi red ovog polinoma, koji je pri svakom ulasku u unutrasnju 
	## petlju jednak tekucoj vrijednosti indeksa spoljasnje petlje. U
	## registru esi se drzi adresa tekuceg koeficijenta starog polinoma
	## dok se u registru edi drzi adresa tekuceg koeficijenta novog
	## polinoma (u pitanju su zapravo iste adrese). Kretanje kroz ove
	## adrese ide prema nanize, pa se u skladu sa tim postavlja vrijednost
	## direction flega.
	push	ecx
	push	esi
	lea	esi, coeffs
	mov	eax, ecx
	mov	edx, 4
	mul	edx
	add	esi, eax
	mov	edi, esi
	std

next_calculation:
	## Nova vrijednost tekuceg koeficijenta se dobija tako sto se stara
	## vrijednost pomnozi sa negiranom vrijednosti tekuce nule polinoma,
	## a potom se ovom proizvodu doda vrijednost koeficijenta sa indeksom
	## za jedan manjim od tekuceg koeficijenta. Ovaj proracun vazi sa
	## sve koeficijente osim slobodnog clana.
	lodsd
	imul	ebx
	add	eax, [esi]
	stosd
	loop next_calculation

	## Nova vrijednost slobodnog clana dobija se tako sto se samo pomnozi
	## stara vrijednost sa negiranom vrijednosti tekuce nule polinoma.
	lodsd
	imul	ebx
	stosd

	## Prelazi se sledecu nulu polinoma u spoljasnoj petlji.
	cld
	pop	esi
	pop	ecx
	jmp next_zero

print:
	## Stampaju se koeficijenti polinoma. U registru ecx se drzi broj
	## koeficijenata, a u registru esi adresa tekuceg koeficijenta.
	mov	ecx, [n]
	inc	ecx
	lea	esi, coeffs
	
next_coeff:
	## Ucitava se naredni koeficijent polinoma.
	lodsd

	## Stampa se koeficijent, prilikom cega se cuva vrijednost brojaca ecx
	## koga ce funkcija printf promijeniti.
	push	ecx
	push	eax
	lea	eax, format
	push	eax
	call printf
	add	esp, 8
	pop	ecx

	## Prelazi se na stampanje narednog koeficijenta.
	loop next_coeff
 	
	## Epilog funkcije.
	popa
	mov	eax, 0
	leave
	ret	
