.intel_syntax noprefix
		
.data
string:	.ascii "abcxyz"		# Dati string.
n:	.int	6		# Duzina stringa.
k:	.int	4		# Kod sifrovanja.
format:	.asciz  "%c"		# Format za ispis sifrovanog stringa.
	
.text
.global  main

main:
	## Prolog funkcije.
        enter   0, 0
        pusha

	## Vrsi se sifrovanje rotacijom ASCII kodova. Adresa tekuceg karaktera
	## se drzi u registrima esi odn. edi, dok se registar ecx koristi kao
	## brojac.
	cld
	lea	esi, string
	mov	edi, esi
	mov	ecx, [n]

ascii_encrypt:
	## Ucitava se naredni karakter i dodaje se k njegovom ASCII kodu.
	lodsb
	add	al, [k]

	## Ukoliko je kod karaktera premasio kod slova 'z', karakter se
	## mapira na pocetak abecede.
	cmp	al, 'z'
	jle ascii_encrypted_back
	sub	al, 26
	
ascii_encrypted_back:
	## Upisuje se sifrovan karakter nazad na svoje mjesto u strigu.
	stosb
	loop ascii_encrypt

	## Rotira se string za jedno mjesto udesno. U registru al drzi se
	## tekuci karakter, u registru edi nalazi se adresa narednog karaktera.
	## Registar ecx se koristi kao brojac.
	mov	al, [string]
	lea	edi, string
	inc	edi
	mov	ecx, [n]
	dec	ecx

rotate_encrypt:
	## Upisuje se tekuci karakter na mjesto narednog, a naredni karakter
	## se dovodi u registar al. Potom se inkrementira adresa narednog
	## karaktera i nastavlja sa petljom.
	xchg	al, [edi]
	inc	edi
 	loop rotate_encrypt

	## Upisuje se poslednji karakter u stringu na mjesto prvog.
	mov	[string], al

	## Stampa se sifrovani string. Adresa tekuceg karaktera se drzi u
	## registru esi, a brojac u registru ecx.
	lea	esi, string
	mov	ecx, [n]

print_next_char:
	## Stampa se naredni karakter sifrovanog stringa.
	push	ecx
	xor	eax, eax
	lodsb
	push	eax
	lea	eax, format
	push	eax
	call printf
	add	esp, 8
	pop	ecx
	loop print_next_char

	## Stampa se znak za novi red.
	xor	eax, eax
	mov	al, '\n'
	push	eax
	lea	eax, format
	push	eax
	call printf
	add	esp, 8
 	
	## Epilog funkcije.
	popa
	mov	eax, 0
	leave
	ret	
