.intel_syntax noprefix
		
.text
.global regex

	## Funkcija regex() provjerava da li dati string odgovara
        ## regularnom izrazu [a]?[bcd]+[e]*. Argumenti funkcije su:
        ##   [ebp+8] - string koji se provjerava
        ## Funkcija vraca 1 ukoliko string odgovara pomenutom izrazu,
	## ond. 0 u suprotnom. Funkcija se u potpunosti podvrgava C 
        ## konvencijama pozivanja.
regex:
	## Prolog funkcije.
        enter   0, 0
        push	esi

	## Za ispitivanje da li string odgovara datom regularnom izrazu
	## bice konstruisan konacni automat. Pored inicijalnog i
	## finalnog stanja, stanja koja se mogu uociti u datom
	## regularnom izrazu su: stanje nakon sto je uocen karakter 'a'
	## (oznaceno sa stage1), stanje nakon sto je uocen neki od
	## karaktera 'b', 'c' ili 'd' (oznaceno sa stage2) i stanje
	## nakon sto je uocen karakter 'e' (oznaceno sa stage3). Za
	## svako od ovih stanja se uzima naredni karakter iz stringa i
	## sprovodi odgovarajuca tranzicija.

	## Registar esi ce prilikom uparivanja stringa sa regularnim
	## izrazom pokazivati na tekuci karakter. Kroz string se prolazi
	## pocev od prvog karaktera pa prema poslednjem.
	cld
	mov	esi, [ebp+8]

	## Ucitava se prvi karakter i prelazi se u odgovarajuce stanje.
	lodsb
	cmp	al, 'a'
	je stage1
	cmp	al, 'b'
	je stage2
	cmp	al, 'c'
	je stage2
	cmp	al, 'd'
	je stage2
	jmp error

stage1:
	## Ucitava se naredni karakter i prelazi se u odgovarajuce stanje.
	lodsb
	cmp	al, 'b'
	je stage2
	cmp	al, 'c'
	je stage2
	cmp	al, 'd'
	je stage2
	jmp error

stage2:
	## Ucitava se naredni karakter i prelazi se u odgovarajuce stanje.
	lodsb
	cmp	al, 'b'
	je stage2
	cmp	al, 'c'
	je stage2
	cmp	al, 'd'
	je stage2
	cmp	al, 'e'
	je stage3
	cmp	al, 0
	je ok
	jmp error

stage3:
	## Ucitava se naredni karakter i prelazi se u odgovarajuce stanje.
	lodsb
	cmp	al, 'e'
	je stage3
	cmp	al, 0
	je ok

error:
	## Vraca se 0 kao rezulat.
	xor	eax, eax
	jmp finish

ok:
	## Vraca se 1 kao rezultat.
	xor	eax, eax
	inc	eax

finish:
	## Epilog funkcije.
	pop	esi
	leave
	ret	
