.intel_syntax noprefix
                
.text
.global mult32
        ## Funkcija mult32() vrsi mnozenje dva data oznacena 32-bitna
	## broja koristeci iskljucivo operaciju sabiranja. Argumenti
	## funkcije su:
        ##   [ebp+8] - prvi operand
        ##   [ebp+12] - drugi operand
        ##   [ebp+16] - adresa lokacija na koje treba smjestiti rezultat
        ## Funkcija se u potpunosti podvrgava C konvencijama pozivanja.
mult32:
        ## Prolog funkcije.
        enter   0, 0
        push    ebx
        push    esi
        push    edi

        ## Operandi se drze u registrima ebx, odnosno esi.
        mov     ebx, [ebp+8]
        mov     esi, [ebp+12]

        ## Odredjuje se znak rezultata, a operandi se po potrebi
        ## pretvaraju u pozitivne brojeve. Registar edi odredjuje da li
        ## je rezultat negativan.  Prvo se odredjuje znak rezultata na
	## osnovu prvog operanda...
        xor     edi, edi        
        cmp     ebx, 0
        jg test_other
        neg     ebx
        xor     edi, 1
        
test_other:
        ## ...a zatim se zaracunava i drugi operand.
        cmp     esi, 0
        jg multiply
        neg     esi
        xor     edi, 1

multiply:
        ## Obavlja se mnozenje. Niza 32 bita rezultata se cuvaju u
        ## registru eax, a visa 32 bita u registru edx.  Registar ecx se
	## koristi kao brojac.
        xor     eax, eax
        xor     edx, edx
        mov     ecx, 32
next_bit:
        ## Ispituje se tekuci bit prvog operanda.  Ukoliko je taj bit
	## jednak 1, drugi operand se zaracunava u parcijalnu sumu.
        shr     ebx
        jnc continue
        add     edx, esi
        
continue:
        ## Parcijalna suma se pomjera za 1 bit udesno.  Na taj nacin,
	## bit najmanje tezine sume, koji predstavlja formiran bit
	## rezultata, se cuva za ubuduce, a parcijalna suma biva
	## pripremljena za naredni korak.
        shrd    eax, edx, 1
        shr     edx, 1
        loop    next_bit

        ## Provjerava se da li treba invertovati znak rezulata.  Ako to
	## nije slucaj, odmah se prelazi na kraj procedure,...
        cmp     edi, 0
        je done

        ## ...a u suprotnom se odredjuje drugi komplement 64-bitnog
	## broja koji predstavlja rezultat.
        not     eax
        not     edx
        add     eax, 1
        adc     edx, 0

done:
        ## Upisuje se rezultat na date lokacije.
        mov     edi, [ebp+16]
        mov     [edi], eax
        mov     [edi+4], edx
        
        ## Epilog funkcije.
        pop     edi
        pop     esi
        pop     ebx
        leave
        ret
