.intel_syntax noprefix

.text
.global convert
        
        ## Funkcija convert() vrsi konverziju datog broja u datu bazu,
        ## pri cemu upisuje cifre broja u dati string.  Argumenti
	## funkcije su:
        ##   [ebp+8] - dati broj
        ##   [ebp+12] - data baza
        ##   [ebp+16] - adresa prvog elementa polja u koje ce biti
        ##              upisani karakteri koji predstavljaju cifre
        ##              konvertovanog broja
        ## Pretpostavlja se da je dati broj nenegativan, te da je baza
        ## broj iz intervala [2,36].  Funkcija se u potpunosti podvrgava
	## C konvencijama pozivanja.
        
convert:
        ## Prolog funkcije.
        enter   0, 0
        push    ebx
        push    edi

        ## U registar eax se ucitava dati broj, a u registar ebx baza u
        ## koju se vrsi konverzija.  Dati broj ce biti sukcesivno
        ## dijeljen sa bazom, kako bi se dobile cifre konvertovanog
        ## broja.  Ove cifre se dobijaju slijeva udesno, tako da se
        ## odlazu na stek da bi se naknadno upisale u dati string pravim
	## redosledom.
        mov     eax, [ebp+8]
        mov     ebx, [ebp+12]

        ## Registar ecx ce sadrzati broj cifara konvertovanog broja.
        xor     ecx, ecx

next_digit:
        ## Izracunava se naredna cifra konvertovanog broja i stavlja
        ## ista na stek.  Istovremeno se inkremenitira broj cifara
	## konvertovanog broja.
        cdq
        idiv    ebx
        push    edx
        inc     ecx
        cmp     eax, 0
        jg next_digit

        ## Registar edi se sadrzati adresu na koju se smjesta karakter
	## koji predstavlja tekucu cifru konvertovanog broja.
        cld
        mov     edi, [ebp+16]
        
next_char:
        ## Skida se naredna cifra konvertovanog broja sa steka i
        ## pretvara u odgovarajuci karakter, koji moze biti decimalna
	## cifra ili pak slovo.
        pop     eax
        cmp     eax, 10
        jge letter_char
        add     eax, '0'
        jmp store_char
letter_char:
        sub     eax, 10
        add     eax, 'a'

store_char:
        ## Smjesta se karakter koji prestavlja narednu cifru
        ## konvertovanog broja na odgovarajuce mjesto u datom nizu
	## karaktera.
        stosb  
        loop next_char

        ## Terminira se nulom niz karaktera koji predstavlja cifre
	## konvertovanog broja.
        xor     eax, eax
        stosb
        
        ## Epilog funkcije.
        pop     edi
        pop     ebx
        leave
        ret
