.intel_syntax noprefix

.text
.global klein

	## Funkcija klein() izracunava Dekartove koordinate tacke na
	## Klajnovoj boci date parametarskim koordinatama.  Argumenti
	## funkcije su:
        ##   [ebp+8] - koeficijent povrsi a
        ##   [ebp+12] - vrijednost parametarske koordinate u za datu
	##              tacku
        ##   [ebp+16] - vrijednost parametarske koordinate v za datu
	##              tacku
        ##   [ebp+20] - adresa na koju treba upisati izracunatu
	##              vrijednost koordinate x
        ##   [ebp+24] - adresa na koju treba upisati izracunatu
	##              vrijednost koordinate y
        ##   [ebp+28] - adresa na koju treba upisati izracunatu
	##              vrijednost koordinate z
        ## Pretpostavka je da je koeficijent povrsi broj veci od 2, kao
        ## i da se date parametarske koordinate u i v nalaze u intervalu
        ## [0,2*pi). Funkcija se u potpunosti podvrgava C konvencijama
	## pozivanja.
klein:
        ## Prolog funkcije.
	enter   0, 0
        push    edi

        ## Izracunavaju se trazene Dekartove koordinate date tacke na
	## povrsi.
        fld     [ebp+16]        # Stek: v
        fld1                    # Stek: v, 1
        fld     st(1)           # Stek: v, 1, v
        fscale                  # Stek: v, 1, 2*v
        fsin                    # Stek: v, 1, sin(2*v)
        fxch    st(2)           # Stek: sin(2*v), 1, v
        fsin                    # Stek: sin(2*v), 1, sin(v)
        fxch                    # Stek: sin(2*v), sin(v), 1
        fld     [ebp+12]        # Stek: sin(2*v), sin(v), 1, u
        fxch                    # Stek: sin(2*v), sin(v), u, 1
        fchs                    # Stek: sin(2*v), sin(v), u, -1
        fld     st(1)           # Stek: sin(2*v), sin(v), u, -1, u
        fscale                  # Stek: sin(2*v), sin(v), u, -1, u/2
        fxch                    # Stek: sin(2*v), sin(v), u, u/2, -1
        ffree   st              # Stek: sin(2*v), sin(v), u, u/2, invalidna vrijednost
        fincstp                 # Stek: sin(2*v), sin(v), u, u/2
        fsincos                 # Stek: sin(2*v), sin(v), u, sin(u/2), cos(u/2)
        fld     st              # Stek: sin(2*v), sin(v), u, sin(u/2), cos(u/2), cos(u/2)
        fmul    st, st(4)       # Stek: sin(2*v), sin(v), u, sin(u/2), cos(u/2), cos(u/2)*sin(v)
        fld     st(2)           # Stek: sin(2*v), sin(v), u, sin(u/2), cos(u/2), cos(u/2)*sin(v), sin(u/2)
        fmul    st, st(6)       # Stek: sin(2*v), sin(v), u, sin(u/2), cos(u/2), cos(u/2)*sin(v), sin(u/2)*sin(2*v)
        fsubp                   # Stek: sin(2*v), sin(v), u, sin(u/2), cos(u/2), cos(u/2)*sin(v)-sin(u/2)*sin(2*v)
        fadd    [ebp+8]         # Stek: sin(2*v), sin(v), u, sin(u/2), cos(u/2), a+cos(u/2)*sin(v)-sin(u/2)*sin(2*v)
        fxch    st(3)           # Stek: sin(2*v), sin(v), a+cos(u/2)*sin(v)-sin(u/2)*sin(2*v), sin(u/2), cos(u/2), u
        fsincos                 # Stek: sin(2*v), sin(v), a+cos(u/2)*sin(v)-sin(u/2)*sin(2*v), sin(u/2), cos(u/2), sin(u), cos(u)
        fmul    st, st(4)       # Stek: sin(2*v), sin(v), a+cos(u/2)*sin(v)-sin(u/2)*sin(2*v), sin(u/2), cos(u/2), sin(u), [a+cos(u/2)*sin(v)-sin(u/2)*sin(2*v)]*cos(u)=x
        mov     edi, [ebp+20]
        fstp    [edi]           # Stek: sin(2*v), sin(v), a+cos(u/2)*sin(v)-sin(u/2)*sin(2*v), sin(u/2), cos(u/2), sin(u)
        fmulp   st(3), st(0)    # Stek: sin(2*v), sin(v), [a+cos(u/2)*sin(v)-sin(u/2)*sin(2*v)]*sin(u)=y, sin(u/2), cos(u/2)
        fmulp   st(4), st       # Stek: cos(u/2)*sin(2*v), sin(v), y, sin(u/2)
        fmulp   st(2), st       # Stek: cos(u/2)*sin(2*v), sin(u/2)*sin(v), y
        mov     edi, [ebp+24]
        fstp    [edi]           # Stek: cos(u/2)*sin(2*v), sin(u/2)*sin(v)
        faddp                   # Stek: sin(u/2)*sin(v)+cos(u/2)*sin(2*v)=z
        mov     edi, [ebp+28]
        fstp    [edi]           # Stek: 
        
	## Epilog funkcije.
        pop     edi
	leave
        ret
