.intel_syntax noprefix

.text
.global rectangle

	## Funkcija rectangle() izracunava vrijednost integrala funkcije
        ## f(x)=e^x, na intervalu [a,b], primjenom metode pravougaonika
	## sa n koraka.  Argumenti funkcije su:
        ##   [ebp+8], [ebp+12] - granice intervala integracije a i b
        ##   [ebp+16] - broj koraka n
        ## Pretpostavka je da je interval integracije ne-prazan, kao i
        ## da je broj n veci od 0.  Funkcija vraca izracunatu vrijednost
        ## integrala.  Funkcija se u potpunosti podvrgava C konvencijama
	## pozivanja.
rectangle:
        ## Prolog funkcije.
        enter   0, 0

        ## Na stek se stavljaju pocetna vrijednost sume vrijednosti date
        ## funkcije u tekucim koracima, korak integracije, kao i pocetna
        ## vrijednost u kojoj se racuna data funkcija u cilju
	## izracunavanja integrala.
        fldz                            # Stek: 0=S
        fld     dword ptr [ebp+8]       # Stek: S, a
        fld     dword ptr [ebp+12]      # Stek: S, a, b
        fsub    st, st(1)               # Stek: S, a, b-a
        fidiv   dword ptr [ebp+16]      # Stek: S, a, (b-a)/n=step
        fxch                            # Stek: S, step, a
        fld1                            # Stek: S, step, a, 1
        fchs                            # Stek: S, step, a, -1
        fld     st(3)                   # Stek: S, step, a, -1, step
        fscale                          # Stek: S, step, a, -1, step/2
        fxch                            # Stek: S, step, a, step/2, -1
        fcomp                           # Stek: S, step, a, step/2
        faddp                           # Stek: S, step, a+step/2=x[0]

        ## Registar ecx ce biti koriscen kao brojac, i u njega se
	## upisuje broj koraka integracije.
        mov     ecx, [ebp+16]
next_step:
        ## Izracunava se vrijednost funkcije u tekucem koraku , i
	## azurira se suma takvih vrijednosti.
        fldl2e                          # Stek: S[i], step, x[i], log2(e)
        fmul    st, st(1)               # Stek: S[i], step, x[i], log2(e)*x[i]=E
        fld	st                      # Stek:	S[i], step, x[i], E, E
	frndint                         # Stek:	S[i], step, x[i], E, int(E)
	fsub	st(1), st               # Stek:	S[i], step, x[i], E-int(E)=frac(E), int(E)
	fxch                            # Stek:	S[i], step, x[i], int(E), frac(E)
	f2xm1                           # Stek:	S[i], step, x[i], int(E), 2^frac(E)-1
	fld1                            # Stek:	S[i], step, x[i], int(E), 2^frac(E)-1, 1
	faddp                           # Stek:	S[i], step, x[i], int(E), 2^frac(E)
	fscale                          # Stek:	S[i], step, x[i], int(E), 2^int(E)*2^frac(E)=2^(int(E)+frac(E))=2^E=2^(log2(e)*x[i])=(2^log2(e))^x[i])=e^x[i]=f(x[i]
        faddp   st(4), st               # Stek:	S[i]+f(x[i])=S[i+1], step, x[i], int(E)
        fcomp                           # Stek:	S[i+1], step, x[i]
        fadd    st, st(1)               # Stek:	S[i+1], step, x[i]+step=x[i+1]
        loop next_step

        ## Mnozi se suma vrijednosti funkcije u tekucim koraku sa
	## vrijednoscu koraka integracije, cime se dobija vrijednost
	## trazenog integrala.
        fcomp                           # Stek:	S[n], step
        fmulp                           # Stek:	S[n]*step=I

	## Epilog funkcije.
	leave
        ret
