.intel_syntax noprefix

.text
.global hidden

	## Funkcija hidden() provjerava da li se string koji je drugi
	## argument funkcije "skriva" u stringu koji je prvi argument.
	## Argumenti funkcije su:
	##   [ebp+8] - prvi string
	##   [ebp+12] - drugi string
	## Funkcija vraca 1 ako se drugi string "skriva" u prvom odn. 0
	## u suprotnom. Funkcija se u potpunosti podvrgava C
	## konvencijama pozivanja.
hidden:
        ## Prolog funkcije.
        enter	0, 0
        push	esi
	push	edi

	## Registar esi ce cuvati adresu tekuceg karaktera drugog stringa,
	## a registar edi adresu tekuceg karaktera prvog stringa.
	cld
	mov	esi, [ebp+12]
	mov	edi, [ebp+8]

	## Izracunava se duzina prvog string i smjesta u registar ecx
	## koji ce sluziti kao brojac.
	push	edi
	call strlen
	add	esp, 4
	mov	ecx, eax

next_character:
	## Ucitava se naredni karakter drugog stringa.
	lodsb

	## Provjerava se da li se doslo do kraja drugog stringa i ako
	## nije nastavlja se sa pretrazivanjem prvog stringa.
	cmp	al, 0
	jne continue

	## Ako se doslo do kraja drugog stringa, znaci da se taj string
	## "skriva" u prvom, pa se vraca 1 kao rezultat funkcije.
	mov	eax, 1
	jmp finish

continue:
	## Trazi se tekuci karakter drugog stringa u prvom stringu.
	repnz scasb

	## Ako je pretrazivanje zavrseno zato sto je registar ecx postao
	## jednak 0, znaci da tekuci karakter drugog stringa nije 
	## pronadjen do kraja prvog stringa, pa se izlazi iz funkcije. 
	## U suprotnom, prelazi se na naredni karakter drugog## stringa.
	jnz not_hidden
	jmp next_character

not_hidden:
	## Postavlja se 0 kao rezultat funkcije.
	xor	eax, eax

finish:
	## Epilog funkcije.
        pop	edi
	pop	esi
        leave
        ret
