#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Maksimalna duzina linije na ulazu. */
#define LINE_LENGTH 80

/* Deklaracija funkcije substring(). */
extern void     substring(char *first, char *other, char **from,
			  int *length);

int
main()
{
	char            line[LINE_LENGTH];	/* Bafer u koji se
						 * ucitavaju stringovi. */
	char           *first,
	               *other;	/* Prvi i drugi string. */
	char           *address;	/* Adresa prvog karaktera u
					 * najduzem zajednickom
					 * podstringu. */
	int             length;	/* Duzina najduzeg zajednickog podstringa. 
				 */

	/* Ucitava se prvi string. */
	assert(fgets(line, LINE_LENGTH, stdin) != NULL);
	if ((length = strlen(line)) > 0 && line[length - 1] == '\n')
		line[--length] = 0;
	assert((first = malloc((length + 1) * sizeof(char))) != NULL);
	strcpy(first, line);

	/* Ucitava se drugi string. */
	assert(fgets(line, LINE_LENGTH, stdin) != NULL);
	if ((length = strlen(line)) > 0 && line[length - 1] == '\n')
		line[--length] = 0;
	assert((other = malloc((length + 1) * sizeof(char))) != NULL);
	strcpy(other, line);

	/* Odredjuje se najduzi zajednicki podstring. */
	substring(first, other, &address, &length);

	/* Ukoliko je najduzi zajednicki podstring neprazan, isti se
	 * ispisuje na standardni izlaz. */
	if (length != 0)
		printf("%.*s\n", length, address);

	/* Oslobadja se memorija koriscena za stringove. */
	free(first);
	free(other);

	return 0;
}
