.intel_syntax noprefix

.text
.global strrstr
        
        ## Procedura strrstr() odredjuje da li je dati string sadrzi
	## drugi string.  Argumenti funkcije su:
        ##   [ebp+8] - string koji se pretrazuje
        ##   [ebp+12] - string koji se trazi
        ## Funkcija vraca indeks na kome pocinje poslednja (krajnja
        ## desna) pojava drugog stringa u prvom, odn. -1 ako drugi
        ## string nije podstring prvog.  Funkcija se u potpunosti
	## podvrgava C konvencijama pozivanja.
strrstr:
        ## Prolog funkcije.
        enter   0, 0
        push    ebx
        push    esi
        push    edi        

        ## Inicijalizuje se direction fleg.
        cld
      
        ## Radi izracunavanja duzine stringova, registar eax se
        ## postavlja na 0.
        xor     eax, eax

        ## Izracunava se duzina prvog stringa i pamti u registru ebx.
        mov     edi, [ebp+8]
        mov     ecx, -1
        repnz scasb
        add     ecx, 2
        neg     ecx
        mov     ebx, ecx

        ## Izracunava se duzina drugog stringa i pamti u registru edx.
        mov     edi, [ebp+12]
        mov     ecx, -1
        repnz scasb
        add     ecx, 2
        neg     ecx
        mov     edx, ecx

        ## U registru eax se izracunava najveci indeks u prvom stringu
	## na kome se moze pojaviti drugi string.  Ukoliko je drugi
	## string duzi od prvog, odmah se vraca -1 kao rezultat.
        mov     eax, ebx
        sub     eax, edx
        cmp     eax, 0
        jl not_found

        ## Ukoliko je drugi string prazan, izracunati indeks upravo
	## predstavlja trazenu vrijednost.
        cmp     edx, 0
        je done

        ## Registar ebx se u nastavku koristi da cuva adresu prvog
	## karaktera drugog stringa.
        mov     ebx, [ebp+12]

        ## U registru esi se izracunava adresa poslednjeg karaktera u
	## prvom stringu na kome se moze pojaviti drugi string.
        mov     esi, [ebp+8]
        add     esi, eax

next_index:
        ## Provjerava se da li je drugi string sadrzan u prvom stringu
        ## pocev od tekuce pozicije u prvom stringu i, ako jeste, odmah
        ## se zavrsava funkcija.  Registar eax, koji je povratna
        ## vrijednost iz funkcije, u tom slucaju sadrzi upravo trazeni
        ## indeks na kome u prvom stringu pocinje pojava drugog stringa.
        mov     edi, ebx
        mov     ecx, edx
        repe cmpsb
        je done

        ## Registar esi se za narednu iteraciju pomjera na adresu
	## prethodnog karaktera u prvom stringu.
        add     esi, ecx
        sub     esi, edx
        dec     esi

        ## Registar eax se azurira na indeks toga karaktera.  Petlja se
        ## prekida ako se proslo unatrag kroz sve karaktere prvog
	## stringa od kojih moze poceti pojava drugog stringa.
        dec     eax
        cmp     eax, 0
        jge next_index

not_found:
        ## Vraca se -1 kao indikator da drugi string nije podstring
	## prvog stringa.
        mov     eax, -1        

done:
        ## Epilog funkcije.
        pop     edi
        pop     esi
        pop     ebx
        leave
        ret
