#include <assert.h>
#include <ctype.h>
#include <stdio.h>
#include <string.h>

/* Maksimalna duzina rijeci. */
#define MAX_LENGTH 20

/* Deklaracija funkcije soundex(). */
extern void     soundex(char *word, char *code);

int
main(void)
{
	char            word[MAX_LENGTH + 1];	/* Data rijec. */
	int             length;	/* Duzina gornje rijeci. */
	char            code[4];	/* Soundex kod gornje rijeci. */
	int             i;	/* Brojac u petljama. */

	/* Ucitava se rijec sa standardnog ulaza. */
	fgets(word, MAX_LENGTH, stdin);
	length = strlen(word);
	if (length > 0 && word[length - 1] == '\n')
		word[--length] = 0;

	/* Provjerava se da li se rijec sastoji samo od slova. */
	assert(length > 0);
	for (i = 0; i < length; ++i)
		assert(isupper(word[i]));

	/* Odredjuje se, i stampa na standardni izlaz, Soundex kod date
	 * rijeci. */
	soundex(word, code);
	printf("%c%c%c%c\n", code[0], code[1], code[2], code[3]);

	return 0;
}
