.intel_syntax noprefix

.data
w:	.int	2		# Sirina slika.
h:	.int	1		# Visina slika.
img0:	.byte	21, 31, 32, 44, 65, 129, 154, 123	# Prva slika.
img1:	.byte	43, 45, 84, 245, 251, 207, 187, 105	# Druga slika.
p:	.byte	12		# Brojilac faktora kompozicije.
n:	.byte	6		# Imenilac faktora kompozicije.
fmt:	.asciz	"%d "		# Format za ispis komponente kompozitne slike.
nl:	.asciz	"\n"		# Format za ispis nove linije.
	
.text
.global  main

main:
	## Prolog funkcije.
        enter   0, 0
        pusha

	## U registar ecx se upisuje broj piksela i ovaj registar ce sluziti
	## kao brojac. Registar esi ce cuvati adresu tekuce komponente prve, 
	## a registar ebx adresu tekuce komponente druge slike.
	cld	
	mov	ecx, [w]
	imul	ecx, [h]
	lea	esi, img0
	lea	ebx, img1

next_pixel:
	## Za pojedinacne piksele, registar ecx ce sluziti kao brojac 
	## komponenti.
	push	ecx
	mov	ecx, 4
	
next_component:
	## U registar al ucitava se komponenta C0 prve slike. Ova komponenta
	## se mnozi sa faktorom p i proizvod p*C0 se odlaze u registar edx.
	lodsb
	mulb	[p]
	mov	dx, ax

	## Da bi se ucitala odgovarajuca komponenta druge slike, privremeno
	## se sadrzaj registra esi stavlja na stek, a u ovaj registar se
	## prebacuje adresa tekuce komponente C1 druge slike i potom se ta
	## komponenta ucitava u registar al.
	push	esi
	mov	esi, ebx
	lodsb

	## U registru bl se formira imenilac q faktora kompozicije, a zatim se
	## od njega oduzima brojilac tog faktora p. Potom se tekuca komponenta
	## druge slike mnozi sa ovom razlikom, odn. u registru ax se formira
	## proizvod (q-p)*C1.
	mov	bl, 1
	push	ecx
	mov	cl, [n]
	shl	bl, cl
	pop	ecx
	sub	bl, [p]
	mulb	bl

	## U registar ebx se vraca adresa tekuce komponente prve, a u registar
	## esi adresa tekuce komponente druge slike.
	mov	ebx, esi
	pop	esi

	## U registru ax formira se zbir p*C0+(q-p)*C1.
	add	ax, dx

	## Dijeli se ovaj zbir sa q (dijeljenje se izvodi siftovanjem udesno),
	## cime se dobija finalna vrijednost za tekucu komponentu kompozitne
	## slike.
	push	ecx
	mov	cl, [n]
	shr	ax, cl
	pop	ecx

	## Ispisuje se tekuca komponenta na standardni izlaz
	push	ecx
	push	eax
	lea	eax, fmt
	push	eax
	call printf
	add	esp, 8
	pop	ecx

	## Prelazi se na narednu komponentu.
	loop next_component

	## Ispisuje se nova linija na standardni izlaz.
	lea	eax, nl
	push	eax
	call printf
	add	esp, 4
	
	## Prelazi se na naredni piksel
	pop	ecx
	loop next_pixel
	
	## Epilog funkcije.
	popa
	mov	eax, 0
	leave
	ret	
