.intel_syntax noprefix
		
.data
day:	.int	1		# Dan u datumu.
month:	.int	1		# Mjesec u datumu.
year:	.int	1970		# Godina u datumu.
okmsg:	.asciz	"Ok\n"		# Poruka u slucaju pravilnog datuma.
invmsg:	.asciz	"Invalid\n"	# Poruka u slucaju nepravilnog datuma.
months:	.int	31,28,31,30,31,30,31,31,30,31,30,31	# Polje sa brojevima dana po mjesecima (za proste godine).

.text
.global  main

main:
	## Prolog funkcije.
        enter   0, 0
        pusha

	## Provjera ispravnosti mjeseca.
	cmpd	[month], 1
	jl invalid
	cmpd	[month], 12
	jg invalid

	## Provjera ispravnosti dana. Broj dana ne smije biti manji od 1, a 
	## ako nije onda se u registar edx ucitava broj dana u datom mjesecu.
	cmpd	[day], 1
	jl invalid
	mov	esi, [month]
	dec	esi
	mov	edx, months[4*esi]

	## Za sve mjesece, osim februara koji se obradjuje posebno, dan se smije
	## biti veci od sadrzaja registra edx.
	cmp	esi, 1
	je february
	cmp	[day], edx
	jg invalid
	jmp ok

february:
	## Za februar se prvo provjerava da li je dan manji odn. veci od 29 i 
	## preduzima se odgovarajuca akcija. U slucaju da je dan jednak 29, 
	## poziva se funkcije leap() cijem rezultatu se dodaje broj dana u 
	## mjesecu (prakticno 28) i na taj nacin se dobija tacan broj dana u
	## februaru bez obzira da li je godina prosta ili prestupna.
	cmp	[day], 29
	jl ok
	jg invalid
	mov	eax, [year]
	push	eax
	call leap
	add	esp, 4
	add	eax, edx
	cmp	[day], eax
	jg invalid

ok:
	## U registar eax stavlja se adresa poruke u slucaju ispravnog datuma.
	lea	eax, okmsg
	jmp	print

invalid:
	## U registar eax stavlja se adresa poruke u slucaju neispravnog datuma.
	lea	eax, invmsg
	
print:
	## Stampa se odgovarajuca poruka.
	push	eax
	call printf
	add	esp, 4
	
finish:
	## Epilog funkcije.
	popa
	mov	eax, 0
	leave
	ret

	## Funkcija leap() odredjuje da li je data godina prestupna. Argumenti 
	## funkcije su:
	## year - data godina (tretira se kao neoznacen broj)
	## Funkcija vraca 0 ako godina nije prestupna, odn. 1 u suprotnom.
	## Funkcija se u potpunosti podvrgava C konvencijama pozivanja.
leap:
#define year [ebp+8]

	## Prolog funkcije.
	enter	0, 0
	push	ebx
	push	edx

	## Godina nije prestupna ako ostatak pri dijeljenju sa 4 nije 0. 
	mov	eax, year
	test	eax, 0x3
	jnz false

	## Godina je djeljiva sa 4, pa je prestupna ako sada nije djeljiva sa 
	## 100.
	xor	edx, edx
	mov	ebx, 100
	div	ebx
	cmp	edx, 0
	jne true

	## Godina je djeljiva sa 100, pa je prestupna ako je sada djeljiva sa 
	## 400, odn. ako je rezultat dijeljenja sa 100 djeljiv sa 4.
	test	eax, 0x3
	jnz false

true:
	## Godina je prestupna i u registar eax se stavlja odgovarajuci 
	##rezultat.
	mov	eax, 1
	jmp	done

false:
	## Godina nije prestupna i u registar eax se stavlja odgovarajuci 
	##rezultat.
	mov	eax, 0

done:
	## Epilog funkcije.
	pop	edx
	pop	ebx
	leave
	ret
	
#undef year
