.intel_syntax noprefix
			
.text
.global perfect

	## Funkcija perfect() izracunava trazeni savrseni
	## broj. Argumenti funkcije su:
        ##   [ebp+8] - redni broj savrsenog broja koji se trazi
        ## Redni broj mora biti veci ili jednak 1 i manji ili jednak
	## 5. Funkcija se u potpunosti podvrgava C konvencijama
	## pozivanja.
perfect:
	## Prolog funkcije.
        enter   0, 0
	push	ebx
	push	esi
	push	edi

	## Registar esi ce sadrzati tekuci stepen broja 2. Registar edi
	## ce cuvati sumu svih stepena broja 2 pocev od 0 do tekuceg
	## stepena. Registar ecx ce biti koriscen kao brojac i
	## inicijalizuje se na redni broj savrsenog broja koji se trazi.
	mov	esi, 1
	mov	edi, 1
	mov	ecx, [ebp+8]

next_power_of_2:
	## Odredjuje se naredni stepen broja 2 i dodaje se u sumu, a
	## potom se ispituje da li je suma prost broj.
	shl	esi, 1
	add	edi, esi

	## Posto je suma uvijek neparan broj, da bi se odredilo da li je
	## ista prost broj provjerava se da li je djeljiva sa bilo kojim
	## neparnim brojem pocev od 3 do kvadratnog korijena iz sume -
	## ovi brojevi ce biti oznaceni terminom faktor i bice drzani u
	## registru ebx.
	mov	ebx, 3

next_factor:
	## Ukoliko je faktor presao kvadratni korijen iz sume, znaci da
	## je suma prost broj.
	mov     eax, ebx
        mul     ebx
        cmp     eax, edi
        jg prime

        ## Ispituje se ostatak pri dijeljenju sume sa faktorom.
	## Ukoliko je taj ostatak jednak 0 to znaci da suma nije prost
	## broj i odmah se prelazi na naredni stepen dvojke.
	xor	edx, edx
        mov     eax, edi
	div     ebx
        cmp     edx, 0
        je next_power_of_2

        ## Uvecava se faktor.
        add     ebx, 2
        jmp next_factor

prime:
	## Dekrementira se brojac i prelazi se na naredni stepen dvojke.
	loop next_power_of_2

	## Mnozi se suma sa tekucim stepenom dvojke dajuci kao rezultat
	## trazeni savrsen broj.
	mov	eax, edi
	mul	esi

	## Epilog funkcije.
	pop	edi
	pop	esi
	pop	ebx
	leave
	ret	
