.intel_syntax noprefix
                
.text
.global singular

        ## Funkcija singular() odredjuje da li je data 3x3
	## matrice cijelih brojeva singularna.  Argumenti funkcije su:
        ##   [ebp+8] - adresa prvog elementa matrice
        ## Funkcija vraca 1 ukoliko je matrica singularna, odnosno 0
	## inace. Funkcija se u potpunosti podvrgava C konvencijama
	## pozivanja.
singular:
        ## Prolog funkcije.
        enter   0, 0
        push    ebx
        push    esi

        ## Registar esi ce pokazivati na prvi element matrice (matrica
	## ce u komentarima biti oznacavana sa M.  Singularnost matrice
	## ce biti odredjena tako sto ce biti izracunata njena
        ## determinanta, a zatim uporedjena ista sa 0.  U registru ebx
	## ce biti akumulirana vrijednost determinante.
        mov     esi, [ebp+8]
        xor     ebx, ebx

        ## Izracunava se vrijednost
        ## m[0][0]*(m[1][1]*m[2][2]-m[1][2]*m[2][1]) i dodaje u
	## vrijednost determinante.
        mov     eax, [esi+20]
        imul    dword ptr [esi+28]
        mov     ecx, eax
        mov     eax, [esi+16]
        imul    dword ptr [esi+32]
        sub     eax, ecx
        imul    dword ptr [esi]
        add     ebx, eax

        ## Izracunava se vrijednost 
        ## -m[0][1]*(m[1][0]*m[2][2]-m[1][2]*m[2][0]) i dodaje u
	## vrijednost determinante.
        mov     eax, [esi+20]
        imul    dword ptr [esi+24]
        mov     ecx, eax
        mov     eax, [esi+12]
        imul    dword ptr [esi+32]
        sub     eax, ecx
        imul    dword ptr [esi+4]
        sub     ebx, eax

        ## Izracunava se vrijednost 
        ## m[0][2]*(m[1][0]*m[2][1]-m[1][1]*m[2][0]) i dodaje u
	## vrijednost determinante.
        mov     eax, [esi+16]
        imul    dword ptr [esi+24]
        mov     ecx, eax
        mov     eax, [esi+12]
        imul    dword ptr [esi+28]
        sub     eax, ecx
        imul    dword ptr [esi+8]
        add     ebx, eax

        ## Odredjuje se da li je matrica signularna.
        jz yes
        xor     eax, eax
        jmp finish
yes:
        mov     eax, 1

finish: 
        ## Epilog funkcije.
        pop     esi
        pop     ebx
        leave
        ret
