.intel_syntax noprefix

.text
.global count
        
        ## Funkcija count() izracunava koliko u datom stringu ima slova,
	## cifara i ostalih karaktera.  Argumenti funkcije su:
        ##   [ebp+8] - adresa prvog karaktera u datom stringu
        ##   [ebp+12] - adresa na koju treba smjestiti broj slova
        ##   [ebp+16] - adresa na koju treba smjestiti broj cifara
        ##   [ebp+20] - adresa na koju treba smjestiti broj ostalih
        ##      	karaktera
        ## Funkcija pretpostavlja da je string terminiran
        ## nulom. Funkcija se u potpunosti podvrgava C konvencijama
	## pozivanja.
count:
        ## Prolog funkcije.
        enter   0, 0
        push    ebx
        push    esi
        push    edi

        ## Inicijalizuju se brojaci.  Registar ebx ce cuvati broj slova,
	## registar ebx broj cifara i registar edx broj ostalih
	## karaktera.
        xor     ebx, ebx
        xor     ecx, ecx
        xor     edx, edx

        ## Inicijalizuju se direction fleg i registar esi za prolazak
        ## kroz string.  Registar esi ce sadrzati adresu narednog
        ## karaktera u stringu.
        cld
        mov     esi, [ebp+8]

next_character:
        ## Ucitava se naredni karakter u al registar i provjerava se da
	## li se doslo do kraja stringa.
        lodsb
        cmp     al, 0
        je done

        ## Provjerava se da li je tekuci karakter malo slovo i ako jeste
	## inkrementira se brojac slova.
        cmp     al, 'a'
        jb check_uppercase
        cmp     al, 'z'
        ja check_uppercase
        inc     ebx
        jmp next_character

check_uppercase:
        ## Provjerava se da li je tekuci karakter veliko slovo i ako
	## jeste inkrementira se brojac slova.
        cmp     al, 'A'
        jb check_digit
        cmp     al, 'Z'
        ja check_digit
        inc     ebx
        jmp next_character

check_digit:
        ## Provjerava se da li je tekuci karakter cifra i ako jeste
	## inkrementira se brojac cifara.
        cmp     al, '0'
        jb other
        cmp     al, '9'
        ja other
        inc     ecx
        jmp next_character

        ## Ako tekuci karakter nije ni slovo ni cifra, inkrementira se
	## brojac ostalih karaktera.
other:
        inc     edx
        jmp next_character

done:
        ## Upisuju se izracunati brojevi pojavljivanja slova, cifara i
	## ostalih kartera u datom stringu na odgovarajuce lokacije date
	## argumentima funkcije.
        mov     edi, [ebp+12]
        mov     [edi], ebx
        mov     edi, [ebp+16]
        mov     [edi], ecx
        mov     edi, [ebp+20]
        mov     [edi], edx

        ## Epilog funkcije.
        pop     edi
        pop     esi
        pop     ebx
        leave
        ret
