.intel_syntax noprefix
        
.text
.global secant

	## Funkcija secant() odredjuje nulu funkcije
        ## f(x)=sin(x)-x*cos(x) metodom sjecice.  Argumenti funkcije su:
        ##   [ebp+8], [ebp+12] - granice intervala u kojem je
        ##                       lokalizovana nula date funkcije
        ##   [ebp+16] - zeljena tacnost
        ## Pretpostavka je da je interval u kome je lokalizovana nula
        ## funkcije neprazan, kao i da je zeljena tacnost broj veci od
        ## 0.  Funkcija vraca vrijednost trazene nule. Funkcija se u
	## potpunosti podvrgava C konvencijama pozivanja.
secant:
        ## Prolog funkcije.
	enter   0, 0

        ## Na stek se ucitavaju zeljena tacnost i vrijednost x[0]=b.
        fld     dword ptr [ebp+16]      # Stek: eps
        fld     dword ptr [ebp+12]      # Stek: eps, b=x[0]=x[n-1]

        ## Racuna se f(x[n-1]).
        fld     st                      # Stek: eps, x[n-1], x[n-1]
        fsincos                         # Stek: eps, x[n-1], sin(x[n-1]), cos(x[n-1])
        fmul    st, st(2)               # Stek: eps, x[n-1], sin(x[n-1]), x[n-1]*cos(x[n-1])
        fsubp                           # Stek: eps, x[n-1], sin(x[n-1])-x[n-1]*cos(x[n-1])=f(x[n-1])

        ## Na stek se ucitava vrijednost x[1]=a.
        fld     dword ptr [ebp+8]       # Stek: eps, x[n-1], f(x[n-1]), a=x[1]=x[n]

again:
        ## Swap-uju se na steku x[n] i x[n-1].
        fxch    st(2)                   # Stek: eps, x[n], f(x[n-1]), x[n-1]

        ## Racuna se f(x[n]).
        fld     st(2)                   # Stek: eps, x[n], f(x[n-1]), x[n-1], x[n]
        fsincos                         # Stek: eps, x[n], f(x[n-1]), x[n-1], sin(x[n]), cos(x[n])
        fmul    st, st(4)               # Stek: eps, x[n], f(x[n-1]), x[n-1], sin(x[n]), x[n]*cos(x[n])
        fsubp                           # Stek: eps, x[n], f(x[n-1]), x[n-1], sin(x[n])-x[n]*cos(x[n])=f(x[n])

        ## Swap-uju se na steku f(x[n]) i f(x[n-1])
        fxch    st(2)                   # Stek: eps, x[n], f(x[n]), x[n-1], f(x[n-1])

        ## Racuna se x[n+1].
        fsub    st, st(2)               # Stek: eps, x[n], f(x[n]), x[n-1], f(x[n-1])-f(x[n])
        fdivr   st, st(2)               # Stek: eps, x[n], f(x[n]), x[n-1], f(x[n])/(f(x[n-1])-f(x[n]))
        fxch    st(1)                   # Stek: eps, x[n], f(x[n]), f(x[n])/(f(x[n-1])-f(x[n])), x[n-1]
        fsub    st, st(3)               # Stek: eps, x[n], f(x[n]), f(x[n])/(f(x[n-1])-f(x[n])), x[n-1]-x[n]
        fmulp                           # Stek: eps, x[n], f(x[n]), f(x[n])/(f(x[n-1])-f(x[n]))*(x[n-1]-x[n])
        fsubr   st, st(2)               # Stek: eps, x[n], f(x[n]), x[n]-f(x[n])/(f(x[n-1])-f(x[n]))*(x[n-1]-x[n])=x[n+1]

        ## Provjerava se da li je postignuta zeljena tacnost; ako nije,
	## nastavlja se sa iteracijama.  Treba primijetiti da je
        ## raspored vrijednsoti na steku isti na kraju svake iteracije
	## kao na njenom pocetku.
        fld     st                      # Stek: eps, x[n], f(x[n]), x[n+1], x[n+1]
        fsub    st, st(3)               # Stek: eps, x[n], f(x[n]), x[n+1], x[n+1]-x[n]
        fabs                            # Stek: eps, x[n], f(x[n]), x[n+1], abs(x[n+1]-x[n])
        fcomip  st, st(4)               # Stek: eps, x[n], f(x[n]), x[n+1]
        jae again

        ## Skidaju se nepotrebne vrijednosti sa steka.
        fxch    st(3)                   # Stek: x[n+1], x[n], f(x[n]), eps
        ffree   st                      # Stek: x[n+1], x[n], f(x[n]), invalidna vrijednost
        fincstp                         # Stek: x[n+1], x[n], f(x[n])
        ffree   st                      # Stek: x[n+1], x[n], invalidna vrijednost
        fincstp                         # Stek: x[n+1], x[n]
        ffree   st                      # Stek: x[n+1], invalidna vrijednost
        fincstp                         # Stek: x[n+1]
        
	## Epilog funkcije.
	leave
        ret
