.intel_syntax noprefix

.text
.global sum

	## Funkcija sum() izracunava sumu datog broja clanova
        ## geometrijske progresije datog broja.  Argumenti funkcije su:
        ##   [ebp+8] - broj za koji se racuna suma clanova geometrijske
	##             progresije
        ##   [ebp+12] - broj clanova geometrijske progresije koji ulaze
	##              u trazenu sumu
        ## Pretpostavka je da je dati broj veci od 1, kao i da je broj
        ## clanova geometrijske progresije koji ulaze u sumu veci od 0.
        ## Funkcija vraca izracunutu sumu.  Funkcija se u potpunosti
	## podvrgava C konvencijama pozivanja.
sum:
        ## Prolog funkcije.
	enter   0, 0

        fld     [ebp+8]         # Stek: x
        fild    [ebp+12]        # Stek: x, n

        ## Racuna se n-ti stepen broja x. U komentarima je sa int()
	## oznacen cjelobrojni, a sa frac() razlomljeni dio realnog broja.
        fld     st(1)           # Stek: x, n, x
        fyl2x                   # Stek: x, n*log2(x)=log2(x^n)=L
        fld     st              # Stek: x, L, L
        frndint                 # Stek: x, L, int(L)
        fsub    st(1), st       # Stek: x, L-int(L)=frac(L), int(L)
        fxch                    # Stek: x, int(L), frac(L)
        f2xm1                   # Stek: x, int(L), 2^frac(L)-1
        fld1                    # Stek: x, int(L), 2^frac(L)-1, 1
        faddp                   # Stek: x, int(L), 2^frac(L)
        fscale                  # Stek: x, int(L), 2^int(L)*2^frac(L)=2^(int(L)+frac(L))=2^L
        fxch                    # Stek: x, 2^L, int(L)
        ffree   st              # Stek: x, 2^L, invalidna vrijednost
        fincstp                 # Stek: x, 2^L=2^log2(x^n)=x^n

        ## Izracunava se trazena suma.
        fld1                    # Stek: x, x^n, 1
        fsub    st(2), st       # Stek: x-1, x^n, 1
        fsubp                   # Stek: x-1, x^n-1
        fdivrp                  # Stek: (x^n-1)/(x-1)

	## Epilog funkcije.
	leave
        ret
