.intel_syntax noprefix
        
.text
.global check

       	## Funkcija check() provjerava ispravnost JMBG broja datog datim
	## stringom. Argumenti funkcije su:
        ##   [ebp+8] - string sa ciframa JMBG broja
        ## Pretpostavka je da se dati string sastoji od 13 karaktera,
        ## koji su sve cifre.  Funkcija vraca 1 ako je dati JMBG
        ## ispravan, odn. 0 u suprotnom.  Funkcija se u potpunosti
	## podvrgava C konvencijama pozivanja.
check:
        ## Prolog funkcije.
        enter   0, 0
        push    ebx
        push    esi

        ## Inicijalizuje se direction fleg.
        cld

        ## Registar ebx ce cuvati adresu tekuce od prvih 6 cifara JMBG
        ## broja, a registar esi adresu tekuce od drugih 6 cifara ovog
	## broja.
        mov     ebx, [ebp+8]
        mov     esi, ebx
        add     esi, 6

        ## Registar cl ce sluziti kao brojac, i istovremeno ce sadrzati
        ## vrijednost kojom se mnozi suma tekucih cifara JMBG broja radi
        ## dobijanja kontrolne cifre.  Registar dx ce sadrzati sumu
	## takvih proizvoda.
        mov     cl, 7
        xor     dx, dx

next_pair:
        ## Ucitava se tekuca od prvih 6 cifara JMBG broja, i smjesta 
	## u registar ch.
        xchg    ebx, esi
        lodsb
        sub     al, '0'
        mov     ch, al

        ## Ucitava se tekuca od drugih 6 cifara JMBG broja, i dodaje joj
	## se tekuca od prvih 6 cifara.
        xchg    ebx, esi
        lodsb
        sub     al, '0'
        add     al, ch

        ## Mnozi se suma tekuceg para cifara sa odgovarajucim brojem,
	## prema formuli za izracunavanje kontrolne sume.
        mul     cl
        add     dx, ax

        ## Azurira se brojac, i eventualno se prelazi na sledeci par
	## cifara.
        dec     cl
        cmp     cl, 1
        ja next_pair

        ## Odredjuje se, polazeci od gore izracunate sume proizvoda, sta
	## bi trebalo da bude kontrolna cifra datog JMBG broja.
        mov     ax, dx
        mov     cl, 11
        div     cl
        sub     ah, 11
        neg     ah
        cmp     ah, 10
        je no_match
        cmp     ah, 11
        jne compare
        mov     ah, 0

compare:
        ## Ucitava se vrijednost kontrolne cifre date brojem, i poredi
	## se sa tacnom vrijednoscu, da bi prema ishodu toga poredjenja
	## bio formiran i rezultat same funkcije.
        lodsb
        sub     al, '0'
        cmp     ah, al
        jne no_match
        mov     eax, 1
        jmp     done
no_match:
        xor     eax, eax        
              
done:
        ## Epilog funkcije.
        pop     esi
        pop     ebx
        leave
        ret
