.intel_syntax noprefix
			
.text
.global classify

        ## Funkcija classify() vrsi klasifikaciju date linije u odnosu
	## na dati pravougaonik. Argumenti funkcije su:
        ##   [ebp+8] - polje sa koordinatama krajnjih tacaka linije
        ##   [ebp+12] - polje sa koordinatama donjeg lijevog, odnosno 
        ##              gornjeg desnog tjemena pravougaonika
        ## Funkcija vraca 0 ako je linija sigurno izvan pravougaonika, 1
	## ako je linija sigurno unutar pravougaonika i -1
        ## inace. Funkcija se u potpunosti podvrgava C konvencijama
	## pozivanja.
classify:
        ## Prolog funkcije.
        enter   0, 0
        push    ebx
        push    esi
        push    edi

        ## Registar esi ce drzati adresu polja sa koordinatama krajnjih
	## tacaka linije, a registar edi adresu polja sa koordinatama
	## donjeg lijevog odnosno gornjeg desnog ugla pravougaonika.
        mov     esi, [ebp+8]
        mov     edi, [ebp+12]
        mov     eax, 1

        ## Porede se x koordinate krajnjih tacaka linije sa lijevom
        ## ivicom pravougaonika.  Ako su obje tacke lijevo od lijeve 
	## ivice pravougaonika, znaci da je linija izvan pravougaonika i
	## prekida se sa daljim testovima.  Ako su pak tacke sa
	## razlicitih strana ove ivice pravougaonika, znaci da linija
	## nikako ne moze biti unutar pravougaonika.
        mov     ecx, [esi]
        mov     edx, [esi+8]
        mov     ebx, [edi]
        cmp     ecx, ebx
        setl    cl
        cmp     edx, ebx
        setl    dl
        test    cl, dl
        jnz outside
        or      cl, dl
        jz right
        xor     eax, eax

right:
        ## Na isti nacin kao gore testiraju se x koordinate krajnjih
	## tacaka linije sa desnom ivicom pravougaonika.
        mov     ecx, [esi]
        mov     edx, [esi+8]
        mov     ebx, [edi+8]
        cmp     ecx, ebx
        setg    cl
        cmp     edx, ebx
        setg    dl
        test    cl, dl
        jnz outside
        or      cl, dl
        jz bottom
        xor     eax, eax

bottom:
        ## Na isti nacin kao gore testiraju se y koordinate krajnjih
	## tacaka linije sa donjom ivicom pravougaonika.
        mov     ecx, [esi+4]
        mov     edx, [esi+12]
        mov     ebx, [edi+4]
        cmp     ecx, ebx
        setl    cl
        cmp     edx, ebx
        setl    dl
        test    cl, dl
        jnz outside
        or      cl, dl
        jz top
        xor     eax, eax

top:
        ## Na isti nacin kao gore testiraju se y koordinate krajnjih
	## tacaka linije sa gornjom ivicom pravougaonika.
        mov     ecx, [esi+4]
        mov     edx, [esi+12]
        mov     ebx, [edi+12]
        cmp     ecx, ebx
        setg    cl
        cmp     edx, ebx
        setg    dl
        test    cl, dl
        jnz outside
        or      cl, dl
        jz finish
        xor     eax, eax

        jmp finish

outside:
        ## Ako je linija izvan pravougaonika, vraca se -1 kao rezultat.
        mov     eax, -1
        
finish:       
        ## Epilog funkcije.
        pop     edi
        pop     esi
        pop     ebx
        leave
        ret
