.intel_syntax noprefix

.data
three:  .int    3
five:   .int    5
                        
.text
.global ugly

        ## Funkcija ugly() odredjuje n-ti po redu "ruzni" broj (cio
	## pozitivan broj ciji su jedini prosti djelioci 2, 3 ili 5),
	## pri cemu je n dato kao argument funkcije.  Argumenti
        ## funkcije su:
        ##   [ebp+8] - redni broj "ruznog" broja koji se trazi
        ## Pretpostavlja se da je redni broj n iz intervala [1,1000].
	## Funkcija se u potpunosti podvrgava C konvencijama pozivanja.
ugly:
        ## Prolog funkcije.
        enter   0, 0
        push    ebx
        push    esi
        push    edi

        ## Registar esi ce u svakom trenutku sadrzati broj dotad
        ## pronadjenih "ruznih" brojeva.  Register edi ce sadrzati redni
        ## broj trazenog "ruznog" broja.  Registar ecx se koristi kao
	## brojac kroz skup pozitivnih cijelih brojeva.
        xor     esi, esi
        mov     edi, [ebp+8]
        xor     ecx, ecx

next_number:
        ## Tekuci broj se uvecava za 1 i prebacuje u registar eax.
        inc     ecx
        mov     eax, ecx

divide_by_2:
        ## Dijeli se tekuci broj sa 2 dogod je djeljiv sa njime.
        shr     eax, 1
        jnc divide_by_2

        ## Ako je rezultat poslednjeg dijeljenja jednak 0 (a ostatak je
	## sigurno 1), znaci da je u prethodnom koraku dobijeno 1 kao
	## rezultat dijeljenja, odn. da broj koji se ispituje
	## predstavlja "ruzan" broj (treba uociti kako se i broj 1
	## prepoznaje kao "ruzan" broj u ovoj tacki),...
        
        cmp     eax, 0
        je found

        ## ... a u suprotnom se registar eax vraca na vrijednost koju je
	## imao prije poslednjeg dijeljenja.
        shl     eax, 1
        or      eax, 1

divide_by_3:
        ## Dijeli se tekuci broj sa 3 dogod je djeljiv sa njime.
        cdq
        div     dword ptr three
        cmp     edx, 0
        je divide_by_3
        
        ## Ako je rezultat poslednjeg dijeljenja jednak 0, a ostatak
	## jednak 1, znaci da je u prethodnom koraku dobijeno 1 kao
	## rezultat dijeljenja, odn. da broj koji se ispituje
	## predstavlja "ruzan" broj,...
        cmp     edx, 1
        jne restore_divided_by_3
        cmp     eax, 0
        je found

restore_divided_by_3:
        ## ... a u suprotnom se registar eax vraca na vrijednost koju je
	## imao prije poslednjeg dijeljenja.
        mov     ebx, edx
        mul     dword ptr three
        add     eax, ebx

divide_by_5:
        ## Dijeli se tekuci broj sa 5 dogod je djeljiv sa njime.
        cdq
        div     dword ptr five
        cmp     edx, 0
        je divide_by_5

        ## Ako je rezultat poslednjeg dijeljenja jednak 0, a ostatak
	## jednak 1, znaci da je u prethodnom koraku dobijeno 1 kao
	## rezultat dijeljenja, odn. da broj koji se ispituje
        ## predstavlja "ruzan" broj.  U suprotnom, nastavlja se sa
	## ispitivanjem da li je naredni cijeli pozitivan broj "ruzan"
	## broj.
        cmp     edx, 1
        jne next_number
        cmp     eax, 0
        jne next_number

found:
        ## Uvecava se broj dosad pronadjenih "ruznih brojeva" i ako je
	## taj broj jednak zadatom broju, prekida se petlja,...
        inc     esi
        cmp     esi, edi
        jne next_number

        ## U trenutku kada se petlja prekine, trazeni "ruzan" broj se
        ## nalazi u registru ecx, pa se isti prebacuje u registar eax
	## kako bi bio vracen kao rezultat iz funkcije.
        mov     eax, ecx 
        
        ## Epilog funkcije.
        pop     edi
        pop     esi
        pop     ebx
        leave
        ret
