#include <assert.h>
#include <stdio.h>
#include <stdlib.h>

/* Deklaracija funkcije fit(). */
extern int      fit(int n, float *x, float *y, float *sigma, float *a,
		    float *b);

int
main(int argc, char **argv)
{
	int             n;	/* Broj mjernih tacaka. */
	float          *x,
	               *y;	/* Nizovi mjernih tacaka i izmjerenih
				 * vrijednosti. */
	float          *sigma;	/* Niz nepreciznosti izmjerenih
				 * vrijednosti. */
	float           a,
	                b;	/* Koeficijenti aproksimirajuce prave. */
	int             i;	/* Brojac u petljama. */

	/* Ucitava se broj mjernih tacaka. */
	scanf("%d", &n);
	assert(n > 2);

	/* Alocira se memorija za nizove mjernih tacaka, izmjerenih
	 * vrijednosti i nepreciznosti i ucitavaju se ove vrijednosti. */
	x = malloc(n * sizeof(float));
	assert(x != NULL);
	y = malloc(n * sizeof(float));
	assert(y != NULL);
	sigma = malloc(n * sizeof(float));
	assert(sigma != NULL);
	for (i = 0; i < n; i++) {
		scanf("%f%f%f", &x[i], &y[i], &sigma[i]);
		assert(sigma[i] != 0);
	}

	/* Poziva se funkcija za odredjivanje koeficijenata
	 * aproksimirajuce prave i eventualno stampaju isti na standarni
	 * izlaz. */
	if (fit(n, x, y, sigma, &a, &b))
		printf("%g %g\n", a, b);

	/* Oslobadja se zauzeta memorija. */
	free(x);
	free(y);
	free(sigma);

	return 0;
}
