.intel_syntax noprefix

.text
.global tr

       	## Funkcija tr() implementira transliteraciju datog stringa.
	## Argumenti funkcije su:
        ##   [ebp+8] - adresa prvog karaktera stringa koji se
	##             transformise            
        ##   [ebp+12] - adresa prvog karaktera stringa sa karakterima
	##              koji se mijenjaju
        ##   [ebp+16] - adresa prvog karaktera stringa sa karakterima u
        ##              koje se mijenjaju karakteri odredjeni prethodnim
	##              argumentom
        ## Pretpostavka je da su duzine stringova koji su dati kao drugi
	## i treci argument funkcije iste. Funkcija se u potpunosti
	## podvrgava C konvencijama pozivanja.
tr:
        ## Prolog funkcije.
        enter   256, 0
        push    ebx
        push    esi
        push    edi

        ## Postoji veci broj nacina da se dati problem rijesi; jedan
        ## moguci pristup pretpostavlja da ce duzina stringa koji se
        ## transformise, kao i broj karaktera za koje se vrsi
        ## transformacija, biti nezanemarljivi, tako da onda ima smisla
        ## utrositi vrijeme na pocetku funkcije za kreiranje tabele
        ## transliteracije.  Prostor u memoriji za ovu tabelu je odvojen
	## na steku.

        ## Postavlja se direction fleg.
        cld

        ## Inicijalizuje se tabela transliteracije.  Registar edi ce
        ## sadrzati adresu tekuceg elementa tabele.  Registar eax se
	## koristi kao brojac.
        lea     edi, [ebp-256]
        xor     eax, eax
next_index:
        stosb
        inc     eax
        cmp     eax, 256
        jl next_index

        ## Modifikuje se tabela transliteracije prema stringovima koji
        ## su dati kao drugi i treci argument funkcije.  Registar esi
        ## sadrzi adresu tekuceg karaktera koji treba mijenjati, a
        ## registar ebx adresu odgovarajuceg karaktera koji ga
        ## zamjenjuje.  Registar edi ce sada sadrzati adresu prvog
	## elementa tabele transliteracije.
        mov     esi, [ebp+12]
        mov     ebx, [ebp+16]
        lea     edi, [ebp-256]
        xor     eax, eax
next_pair:
        lodsb 
        cmp     al, 0
        je transformation
        mov     dl, [ebx]
        inc     ebx        
        mov     [edi+eax], dl
        jmp next_pair

transformation:
        ## Obavlja se sama transliteracija.  Registar ebx sada sadrzi
        ## adresu prvog elementa tabele transliteracije, a registri esi
        ## i edi adrese tekuceg karaktera stringa nad kojim se vrsi
	## transliteracija.
        lea     ebx, [ebp-256]
        mov     esi, [ebp+8]
        mov     edi, [ebp+8]
next_char:
        lodsb
        cmp     al, 0
        je done
        xlatb
        stosb
        jmp next_char        

done:        
        ## Epilog funkcije.
        pop     edi
        pop     esi
        pop     ebx
        leave
        ret
