#include <assert.h>
#include <stdio.h>
#include <stdlib.h>

/* Deklaracija funkcije invest(). */
extern void     invest(int count, float *stocks, float *balance);

int
main()
{
	int             count;	/* Duzina perioda investiranja. */
	float          *stocks;	/* Polje sa vrijednostima akcija tokom
				 * gornjeg perioda. */
	float           balance;	/* Kolicina novca koja se
					 * posjeduje. */
	int             i;	/* Brojac u petljama. */

	/* Ucitava se duzina perioda investiranja i provjerava njegova
	 * validnost. */
	scanf("%d", &count);
	assert(count > 0);

	/* Alocira se memorija za polje sa vrijednostima akcija i
	 * ucitavaju se te vrijednosti, pri cemu se provjerava njihova
	 * validnost. */
	stocks = malloc(count * sizeof(float));
	for (i = 0; i < count; ++i) {
		scanf("%f", &stocks[i]);
		assert(stocks[i] >= 0);
	}

	/* Ucitava se inicijalna kolicina novca sa kojom se raspolaze i
	 * provjerava se njena validnost. */
	scanf("%f", &balance);
	assert(balance > 0);

	/* Obavlja se investiranje kroz dati period i stampa se finalna
	 * kolicina novca. */
	invest(count, stocks, &balance);
	printf("%g\n", balance);

	/* Oslobadja se memorija koriscena za polje sa vrijednostima
	 * akcija. */
	free(stocks);

	return 0;
}
