#include <assert.h>
#include <math.h>
#include <stdio.h>

/* Konstante za lakse indeksiranje komponetni vektora i boja. */
#define X 0
#define Y 1
#define Z 2
#define R 0
#define G 1
#define B 2

/* Dozvoljena greska u zaokruzivanju kod operacija sa realnim brojevima. */
#define EPSILON 1e-6

/* Deklaracija funkcije diffuse(). */
extern void     diffuse(float *N, float *L, float *kd, float *I,
			float *Cd);

int
main()
{
	float           N[3];	/* Vektor normale u datoj tacki na povrsi. 
				 */
	float           L[3];	/* Vektor od date tacke prema svijetlu. */
	float           kd[3];	/* Koeficijenti difuzne refleksije
				 * materijala povrsi. */
	float           I[3];	/* Kompomente intenziteta svijetla. */
	float           Cd[3];	/* Komponente difuznog osvjetljenja koje
				 * treba izracunati. */

	/* Ucitava se vektor normale. */
	scanf("%f%f%f", &N[X], &N[Y], &N[Z]);
	assert(fabs(sqrt(N[X] * N[X] + N[Y] * N[Y] + N[Z] * N[Z]) - 1) <
	       EPSILON);

	/* Ucitava se vektor od date tacke prema svijetlu. */
	scanf("%f%f%f", &L[X], &L[Y], &L[Z]);
	assert(fabs(sqrt(L[X] * L[X] + L[Y] * L[Y] + L[Z] * L[Z]) - 1) <
	       EPSILON);

	/* Ucitavaju se koeficijenti difuzne refleksije materijala. */
	scanf("%f%f%f", &kd[R], &kd[G], &kd[B]);
	assert(kd[R] >= 0 && kd[R] <= 1 && kd[G] >= 0 && kd[G] <= 1
	       && kd[B] >= 0 && kd[B] <= 1);

	/* Ucitava se intenzitet svijetla. */
	scanf("%f%f%f", &I[R], &I[G], &I[B]);
	assert(I[R] >= 0 && I[R] <= 1 && I[G] >= 0 && I[G] <= 1
	       && I[B] >= 0 && I[B] <= 1);

	/* Izracunavaju se i stampaju na standardni izlaz komponente
	 * difuznog osvjetljenja. */
	diffuse(N, L, kd, I, Cd);
	printf("%g %g %g\n", Cd[R], Cd[G], Cd[B]);

	return 0;
}
