.intel_syntax noprefix

.text
.global wc
        
        ## Funkcija wc() broji rijeci i linije u datom nizu 
	## karaktera.  Argumenti funkcije su:
        ##   [ebp+8] - adresa prvog karaktera u nizu
        ##   [ebp+12] - duzina niza
        ##   [ebp+16] - adresa na koju treba upisati broj rijeci
        ##   [ebp+20] - adresa na koju treba upisati broj linija
        ## Funkcija se u potpunosti podvrgava C konvencijama pozivanja.
wc:
        ## Prolog funkcije.
        enter   0, 0
        push    ebx
        push    esi
        push    edi

        ## Incijalizuje se direction fleg.
        cld

        ## Registar esi ce pokazivati na adresu tekuceg karaktera, a
        ## registar ecx ce biti koriscen kao brojac u petlji.  Bit
	## najmanje tezine registra edi oznacava da li se prilikom
        ## procesiranja nalazimo unutar rijeci (vrijednost 1) ili izvan
	## rijeci (vrijednost 0).        
        mov     esi, [ebp + 8]
        mov     ecx, [ebp + 12]
        xor     edi, edi

        ## Registri ebx i edx ce brojati rijeci odn. linije teksta.
        xor     ebx, ebx
        xor     edx, edx

        ## U petlji se procesiraju karakteri datog teksta.
        jecxz done
again:
        ## Ucitava se naredni karakter.
        lodsb

        ## Provjerava se da li je u pitanju space karakter (u slucaju
	## znaka za novu liniju inkrementira se broj linija.
        cmp     al, ' '
        je space
        cmp     al, '\t'
        je space
        cmp     al, '\n'
        jne not_space
        inc     edx

space:
        ## U slucaju space karaktera postavlja se fleg koji oznacava da
	## li se nalazimo unutar rijeci na 0.       
        xor     edi, edi
        jmp next
        
not_space:
        ## U slucaju ako nije u pitanju space karakter provjerava se li
        ## smo se nalazili izvan rijeci i ako je tako inkrementira se
        ## broj rijeci.  Fleg koji oznacava da li se nalazimo unutar
	## rijeci se istovremeno postavlja na 1.
        bts     edi, 0
        jc next
        inc     ebx     

next:
        ## Nastavlja se sa procesiranjem.
        loop again

        ## Provjerava se da li je tekst zavrsen znakom za novu liniju i
	## ako je to slucaj, inkrementira se broj linija u tekstu.
        cmp     al, '\n'
        je done
        inc     edx
        
done:
        ## Upisuju se broj rijeci i broj linija na date lokacije u
	## memoriji.
        mov     edi, [ebp + 16]
        mov     [edi], ebx
        mov     edi, [ebp + 20]
        mov     [edi], edx

        ## Epilog funkcije.
        pop     edi
        pop     esi
        pop     ebx
        leave
        ret
