#include <assert.h>
#include <stdio.h>
#include <stdlib.h>

/* Deklaracija funkcije mandelbrot(). */
extern int      mandelbrot(int size, char *pixels);

int
main(int argc, char **argv)
{
	int             size;	/* Dimenzija slike koja se generise. */
	char           *pixels;	/* Pikseli slike */
	int             x,
	                y;	/* Indeksi piksela. */
	int             index;	/* Indeks tekuceg piksela. */

	/* Provjerava se da program ima dva argumenta. */
	assert(argc == 2);

	/* Odredjuje se dimenzija slike. */
	size = atoi(argv[1]);
	assert(size > 0);

	/* Alocira se memorija za piksele slike. */
	pixels = malloc(size * size * sizeof(char));

	/* Popunjavaju se pikseli slike (pocev od donjeg reda piksela
	 * prema gornjem redu). */
	mandelbrot(size, pixels);

	/* Ispisuje se sadrzaj slike na standardni izlaz u plain PBM
	 * formatu. */
	printf("P1\n");
	printf("%d %d\n", size, size);
	for (y = size - 1; y >= 0; y--) {
		index = y * size;
		for (x = 0; x < size; x++, index++)
			if (x < size - 1)
				printf("%c ", pixels[index]);
			else
				printf("%c\n", pixels[index]);
	}

	/* Oslobadja se memorija koriscena za piksele slike. */
	free(pixels);

	return 0;
}
