.intel_syntax noprefix
        
.text
.global armstrong3

       	## Funkcija armstrong3() odredjuje koliko ima trocifrenih
        ## Armstrongovih brojeva.  Funkcija nema argumenata, a inace se
	## u potpunosti podvrgava C konvencijama pozivanja.
armstrong3:
        ## Prolog funkcije.
        enter   4, 0
        push    ebx
        push    esi
        push    edi

        ## Funkcija ima jednu lokalnu promjenljivu, koja ce cuvati
        ## vrijednost rezultata funkcije (odabrano je da bas ova
        ## vrijednost bude lokalna promjenljiva, jer je najvjerovatnije
        ## da ce ta vrijednost tokom izvrsavanja funkcija najmanje puta
	## biti azurirana); ova vrijednost se inicijalizuje na 0.
        xor     ecx, ecx
        mov     [ebp-4], ecx

        ## Registar ebx ce sadrzati tekucu cifru koja predstavlja
	## stoticu.
        mov     ebx, 1
next_hundreds:
        ## Registar ecx ce sadrzati razliku datog broja i sume kubova
	## njegovih cifara; neka oznaka ove velicine bude D.
        xor     ecx, ecx

        ## Zaracunava se u D vrijednost koju nosi cifra koja predstavlja
	## stoticu.
        mov     eax, 100
        mul     ebx
        add     ecx, eax

        ## Zaracunava se u D kub cifre koja predstavlja stoticu.
        mov     eax, ebx
        mul     ebx
        mul     ebx
        sub     ecx, eax

        ## Registar esi ce sadrzati tekucu cifru koja prestavlja
	## deseticu.
        mov     esi, 0
next_tens:
        ## Cuva se tekuca vrijednost D, kako bi za datu stoticu mogla
        ## biti iskoricena za sve kombinacije vrijednosti desetica i
	## jedinica.
        push    ecx

        ## Zaracunava se u D vrijednost koju nosi cifra koja predstavlja
	## deseticu.
        mov     eax, 10
        mul     esi
        add     ecx, eax

        ## Zaracunava se u D kub cifre koja predstavlja deseticu.
        mov     eax, esi
        mul     esi
        mul     esi
        sub     ecx, eax

        ## Registar esi ce sadrzati tekucu cifru koja prestavlja
	## jedinicu.
        mov     edi, 0
next_ones:
        ## Cuva se tekuca vrijednost D, kako bi za datu stoticu i
        ## deseticu mogla biti iskoricena za sve vrijednosti jedinica.
        push    ecx

        ## Zaracunava se u D vrijednost koju nosi cifra koja predstavlja
	## jedinicu.
        add     ecx, edi

        ## Zaracunava se u D kub cifre koja predstavlja jedinicu.
        mov     eax, edi
        mul     edi
        mul     edi
        sub     ecx, eax

        ## Ako je vrijednost D u ovom trenutku jednaka 0, to znaci da je
        ## broj predstavljen tekucom stoticom, deseticom i jedinicom
        ## jednak sumi kubova tih svojih cifara, pa se inkrementira
	## vrijednost rezultata.
        jnz continue
        inc     dword ptr [ebp-4]
                
continue:
        ## Vraca se sa steka vrijednost D za tekucu deseticu.
        pop     ecx

        ## Prelazi se na narednu jedinicu.
        inc     edi
        cmp     edi, 10
        jl next_ones

        ## Vraca se sa steka vrijednost D za tekucu stoticu.
        pop     ecx

        ## Prelazi se na narednu deseticu.
        inc     esi
        cmp     esi, 10
        jl next_tens

        ## Prelazi se na narednu stoticu.
        inc     ebx
        cmp     ebx, 10
        jl next_hundreds

        ## Prebacuje se vrijednost rezultata u registar eax.
        mov     eax, [ebp-4]

        ## Epilog funkcije.
        pop     edi
        pop     esi
        pop     ebx
        leave
        ret
