#include <assert.h>
#include <stdio.h>
#include <stdlib.h>

/* Deklaracija funkcije moving_averages(). */
extern void     moving_averages(int n, float *x, int m, float *y);

int
main(void)
{
	int             n;	/* Duzina datog vektora. */
	float          *x;	/* Polje sa elementima datog vektora. */
	int             m;	/* Broj elemenata koji se uzimaju u obzir
				 * pri racunanju "pokretnih" artitmetickih 
				 * sredina. */
	float          *y;	/* Polje sa elementima vektora "pokretnih" 
				 * aritmetickih sredina. */
	int             i;	/* Brojac u petljama. */

	/* Ucitava se duzina datog vektora. */
	scanf("%d", &n);
	assert(n > 0);

	/* Alocira se memorija za elemente datog vektora, i ucitavaju se
	 * njihove vrijednosti. */
	x = malloc(n * sizeof(float));
	assert(x != NULL);
	for (i = 0; i < n; ++i)
		scanf("%f", &x[i]);

	/* Ucitava se broj elemenata koji se uzimaju u obzir pri racunanju 
	 * "pokretnih" artitmetickih sredina. */
	scanf("%d", &m);
	assert(m > 0 && m <= n);

	/* Alocira se memorija za elemente vektora "pokretnih"
	 * aritmetickih sredina. */
	y = malloc((n - m + 1) * sizeof(float));
	assert(y != NULL);

	/* Izracunavaju se elementi vektora "pokretnih" aritmetickih
	 * sredina. */
	moving_averages(n, x, m, y);

	/* Stampa se vektor "pokretnih" aritmetickih sredina. */
	printf("%d\n", n - m + 1);
	for (i = 0; i < n - m + 1; ++i)
		printf("%g ", y[i]);
        printf("\n");

	/* Oslobadja se sva alocirana memorija. */
	free(x);
	free(y);

	return 0;
}
