.intel_syntax noprefix

.data
ten:	.int	10	# Broj 10.
	
.text
.global resistance

	## Funkcija resistance() izracunava multiplikativnu otpornost
	## datog broja. Argumenti funkcije su:
	##   [ebp+8] - broj cija se multiplikativna otpornost racuna
	## Pretpostavka je da je arugment funkcije pozitivan. Funkcija
	## vraca vrijednost multiplikativne otpornosti. Funkcija se u
	## potpunosti podvrgava C konvencijama pozivanja.
resistance:
        ## Prolog funkcije.
        enter	0, 0
	push	ebx
	push	esi
	push	edi

	## U registru ebx se drzi broj ciji se proizvod cifara odredjuje
	## u tekucoj iteraciji. Registar ecx cuva vrijednost
	## multiplikativne otpornosti.
	mov	ebx, [ebp+8]
	xor	ecx, ecx
	
again: 
	
	## U registru esi drzi se broj cifara broja u tekucoj
	## iteraciji. Registar edi sadrzi proizvod cifara tog broja.
	xor	esi, esi
	mov	edi, 1
	
next_digit:
	## Inkrementira se broj cifara datog broja.
	inc	esi

	## Dijeli se broj sa 10 da bi se izdvojila jedna njegova
	## cifra. Kolicnik se vraca u registar ebx da bi kasnije na isti
	## nacin bile izdvojene i ostale cifre. Ostatak pri dijeljenju je
	## cifra koja je izdvojena i ista ostaje u registru edx. Broj 10 
	## se cuva u jednoj memorijskoj lokaciji obzirom da nema 
	## slobodnog registra u koji bi bio smjesten.
	mov	eax, ebx
	cdq
	div	dword ptr ten
	mov	ebx, eax

	## Mnozi se proizvod cifara broja sa cifrom koja je upravo
	## izdvojena i rezultat se vraca natrag u registar edi.
	mov	eax, edi
	mul	edx
	mov	edi, eax

	## Provjerava se da li su sve cifre broja obradjene i ako nisu
	## nastavlja se sa narednom cifrom.
	cmp	ebx, 0
	jne next_digit

	## Provjerava se da li je broj cifara tekuceg broja jednak 1 i
	## ako jeste zavrsava se sa iterativnim postupkom.
	cmp	esi, 1
	je finish

	## Inkrementira se multiplikativna otpornost i proizvod cifara
	## tekuceg broja postaje tekuci broj za narednu iteraciju.
	
	inc	ecx
	mov	ebx, edi
	jmp again
	
finish:
	## Izracunata multiplikativna otpornost se vraca kao rezultat.
	mov	eax, ecx
	
	## Epilog funkcije.
	pop	edi
	pop	esi
	pop	ebx
        leave
        ret
