#include <assert.h>
#include <stdio.h>
#include <stdlib.h>

/* Deklaracija funkcije haar(). */
extern void     haar(int p, float *x);

int
main()
{
	int             p,
	                n;	/* Duzina ulaznog vektora izrazena kao
				 * stepen dvojke i kao obican broj. */
	float          *x;	/* Ulazni vektor. */
	int             i;	/* Brojac u petljama. */

	/* Ucitava se duzina ulaznog vektora. */
	scanf("%d", &p);
	assert(p >= 1 && p <= 16);
	n = 1 << p;

	/* Alocira se memorija i ucitavaju se elementi ulaznog vektora. */
	x = malloc(n * sizeof(float));
	assert(x != NULL);
	for (i = 0; i < n; i++)
		scanf("%f", &x[i]);

	/* Izracunava se DWT vektora. */
	haar(p, x);

	/* Stampaju se duzina i elementi rezultujuceg vektora na standarni 
	 * izlaz. */
	printf("%d\n", p);
	for (i = 0; i < n; i++)
		printf("%g\n", x[i]);

	/* Oslobadja se memorija koriscena za smjestaj elemenata vektora. */
	free(x);

	return 0;
}
