.intel_syntax noprefix

.text
.global merge
        
        ## Funkcija merge() spaja elemente dva sortirana ulazna niza u
	## sortirani izlazni niz.  Argumenti funkcije su:
        ##   [ebp+8] - duzina prvog ulaznog niza
        ##   [ebp+12] - adresa prvog elementa prvog ulaznog niza
        ##   [ebp+16] - duzina drugog ulaznog niza
        ##   [ebp+20] - adresa prvog elementa drugog ulaznog niza
        ##   [ebp+24] - adresa prvog elementa izlaznog niza
        ## Pretpostavka je da su duzine ulaznih nizova brojevi veci od
        ## 0, kao i da su ulazni nizovi sortirani.  Funkcija se u
	## potpunosti podvrgava C konvencijama pozivanja.
merge:
        ## Prolog funkcije.
        enter   0, 0
        push    ebx
        push    esi
        push    edi

        ## Postavlja se direction fleg.
        cld

        ## U glavnoj petlji, registar esi ce sadrzati adresu prvog
        ## elementa prvog ulaznog niza, registar ebx adresu prvog
        ## elementa drugog ulaznog niza, a registar edi adresu tekuceg
        ## elementa izlaznog niza.  Takodje, registar ecx ce sadrzati
        ## indeks tekuceg elementa prvog ulaznog niza, a registar edx
	## indeks tekuceg elementa drugog ulaznog niza.
        mov     esi, [ebp+12]
        xor     ecx, ecx
        mov     ebx, [ebp+20]
        xor     edx, edx
        mov     edi, [ebp+24]
next_element:
        ## Provjerava se da li se doslo do kraja prvog niza.
        cmp     ecx, [ebp+8]
        jge first_array_done

        ## Provjerava se da li se doslo do kraja drugog ulaznog niza.
        cmp     edx, [ebp+16]
        jge second_array_done

        ## Prebacuje se tekuci element prvog ulaznog niza u eax registar
	## i poredi sa tekucim elementom drugog ulaznog niza.
        mov     eax, [esi+4*ecx]
        cmp     eax, [ebx+4*edx]
        jg second_current_smaller

        ## Ako je tekuci element prvog ulaznog niza manji, isti se
        ## ostavlja u eax registru i inkrementira se indeks tekuceg
	## elementa ovog niza.
        inc     ecx
        jmp store_element

second_current_smaller:
        ## Ako je tekuci element drugog ulaznog niza manji, isti se
        ## prebacuje u eax registar i inkrementira se indeks tekuceg
	## elementa ovog niza.
        mov     eax, [ebx+4*edx]
        inc     edx
                
store_element:
        ## Upisuje se manji od tekucih elemenata ulaznih nizova (koji se
	## nalazi u registru eax) u izlazni niz i prelazi se narednu
	## iteraciju.
        stosd        
        jmp next_element

first_array_done:
        ## Registar esi se postavlja na adresu prvog elementa niza koji
        ## sadrzi preostale elemente, registar ecx na broj elemenata
        ## toga niza, a registar edx na broj elemenata toga niza koji su
	## upisani u izlazni niz.
        mov     esi, ebx
        mov     ecx, [ebp+16]
        jmp finalize
        
second_array_done:
        ## Registri esi, ecx i edx se postavljaju na iste vrijednosti
	## kao u prethodnom slucaju.
        mov     edx, ecx
        mov     ecx, [ebp+8]

finalize:
        ## Upisuju se preostali elementi u izlazni niz.
        sub     ecx, edx
        shl     edx, 2
        add     esi, edx
        rep movsd
        
        ## Epilog funkcije.
        pop     edi
        pop     esi
        pop     ebx
        leave
        ret
