#include <assert.h>
#include <stdio.h>
#include <stdlib.h>

/* Deklaracija funkcije merge(). */
extern void     merge(int n0, int *v0, int n1, int *v1, int *v);

int
main()
{
	int             n0,
	                n1;	/* Duzine ulaznih nizova. */
	int            *v0,
	               *v1;	/* Polja sa elementima ulaznih nizova. */
	int             n;	/* Duzina izlaznog niza. */
	int            *v;	/* Polje sa elementima izlaznog niza. */
	int             i;	/* Brojac u petljama. */

	/* Ucitava se duzina prvog ulaznog niza, alocira se memorija za
	 * njegove elemente i ucitavaju se isti. */
	scanf("%d", &n0);
	assert(n0 > 0);
	v0 = malloc(n0 * sizeof(int));
	assert(v0 != NULL);
	for (i = 0; i < n0; i++)
		scanf("%d", &v0[i]);
	for (i = 0; i < n0 - 1; i++)
		assert(v0[i] <= v0[i + 1]);

	/* Ucitava se duzina drugog ulaznog niza, alocira se memorija za
	 * njegove elemente i ucitavaju se isti. */
	scanf("%d", &n1);
	assert(n1 > 0);
	v1 = malloc(n1 * sizeof(int));
	assert(v1 != NULL);
	for (i = 0; i < n1; i++)
		scanf("%d", &v1[i]);
	for (i = 0; i < n1 - 1; i++)
		assert(v1[i] <= v1[i + 1]);

	/* Alocira se memorija za izlazni niz i poziva se procedura
	 * merge() da popuni ovaj niz. */
	n = n0 + n1;
	v = malloc(n * sizeof(int));
	assert(v != NULL);
	merge(n0, v0, n1, v1, v);

	/* Oslobadja se memorija koriscena za elemented ulaznih nizova. */
	free(v0);
	free(v1);

	/* Ispisuje se izlazni niz. */
	printf("%d", n);
	for (i = 0; i < n; i++)
		printf(" %d", v[i]);
	printf("\n");

	/* Oslobadja se memorija koriscena za elemente izlaznog niza. */
	free(v);

	return 0;
}
