.intel_syntax noprefix

.data
count:  .int    5               # Broj osoba koji ucestvuju u podjeli.

.text
.global coconuts
        
        ## Procedura coconuts() resava tzv. problem kokosovih oraha.
        ## Funkcija nema argumenata, a vraca pocetni broj oraha na
        ## gomili koji predstavlja resenje problema. Funkcija se u
	## potpunosti podvrgava C konvencijama pozivanja.
coconuts:
        ## Prolog funkcije.
        enter   0, 0
        push    ebx
        push    esi
        push    edi

        ## Registar ebx ce sadrzati pocetni broj oraha na gomili koji se
        ## testira.  Registar esi ce sadrzati broj osoba koji ucestvuju
	## u podjeli.
        xor     ebx, ebx
        mov     esi, count
again:
        ## Inkrementira se pocetni broj oraha na gomili za sledecu
	## iteraciju.
        inc     ebx

        ## Simuliraju se desavanja tokom noci. Registar edi ce sadrzati
        ## tekuci broj oraha na gomili.  Registar ecx ce biti koriscen
	## kao brojac u petlji i inicijalizuje se na broj osoba.
        mov     edi, ebx
        mov     ecx, esi
next_person:
        ## Odredjuje se velicina dijela gomile koja pripada svakoj
        ## osobi.  Ta velicina mora biti veca od 0, takodje nakon
        ## podjele na gomili mora ostati jedan orah; ako neki od ovih
        ## uslova nije ispunjen, onda tekuca vrijednost za pocetni broj
        ## oraha na gomili nije resenje problema i nastavlja se sa
	## sledecim pokusajem.
        mov     eax, edi
        cdq
        idiv    esi
        cmp     edx, 1
        jne again
        cmp     eax, 0
        jle again

        ## Iz gomile se oduzima dio koji u datom trenutku pripada
	## tekucoj osobi, kao i jedan orah koji je visak.
        sub     edi, eax
        dec     edi
        loop next_person

        ## Simuliraju se jutarnja desavanja - gomila se opet dijeli na
        ## jednake djelove.  Pritom, velicina svakog dijela mora biti
        ## veca od 0, a takodje nakon podjele na gomili ne smije ostati
        ## ni jedan orah; ako neki od ovih uslova nije ispunjen, onda
        ## tekuca vrijednost za pocetni broj oraha na gomili nije
	## resenje problema i nastavlja se sa sledecim pokusajem.
        mov     eax, edi
        cdq
        idiv    esi
        cmp     edx, 0
        jne again
        cmp     eax, 0
        jle again

        ## Ukoliko su svi testovi uspjesno prodjeni, znaci da je tekuca
        ## vrijednost za pocetni broj oraha rjesenje problema, tako da
	## se ta vrijednost smjesta u registar eax kao rezultat
	## funkcije.
        mov     eax, ebx
        
        ## Epilog funkcije.
        pop     edi
        pop     esi
        pop     ebx
        leave
        ret
