#include <assert.h>
#include <stdio.h>
#include <stdlib.h>

/* Deklaracija funkcije product(). */
extern void     product(int m, float *p, int n, float *q, float *r);

int
main()
{
	int             m,
	                n;	/* Stepeni datih polinoma. */
	float          *p,
	               *q;	/* Polja koeficijenata datih polinoma. */
	float          *r;	/* Polje koeficijenata polinoma proizvoda. 
				 */
	int             i;	/* Brojac u petljama. */

	/* Ucitava se stepen prvog polinoma, a zatim se alocira potrebna
	 * memorija i ucitavaju koeficijenti istog. */
	scanf("%d", &m);
	assert(m >= 0);
	p = malloc((m + 1) * sizeof(float));
	assert(p != NULL);
	for (i = 0; i <= m; ++i)
		scanf("%f", &p[i]);

	/* Ucitava se stepen drugog polinoma, a zatim se alocira potrebna
	 * memorija i ucitavaju koeficijenti istog. */
	scanf("%d", &n);
	assert(n >= 0);
	q = malloc((n + 1) * sizeof(float));
	assert(q != NULL);
	for (i = 0; i <= n; ++i)
		scanf("%f", &q[i]);

	/* Alocira se memorija za koeficijente polinoma proizvoda i
	 * izracunavaju se isti. */
	r = malloc((m + n + 1) * sizeof(float));
	assert(r != NULL);
	product(m, p, n, q, r);

	/* Stampa se polinom proizvoda. */
	printf("%d", m + n);
	for (i = 0; i <= m + n; ++i)
		printf(" %g", r[i]);
	printf("\n");

	/* Oslobadja se memorija koriscena za koeficijente polinoma. */
	free(p);
	free(q);
	free(r);

	return 0;
}
