.intel_syntax noprefix
        
.text
.global divsum

       	## Funkcija divsum() odredjuje sumu "pravih" djelilaca (onih
        ## koji su razliciti od samog broja) datog cijelog broja.
	## Argumenti funkcije su:
        ##   [ebp+8] - dati broj
        ## Funkcija vraca trazenu sumu. Pretpostavka je da je dati broj
        ## pozitivan.  Funkcija se u potpunosti podvrgava C konvencijama
	## pozivanja.
divsum:
        ## Prolog funkcije.
        enter   0, 0
        push    ebx
        push    edi

        ## Registar ebx ce sadrzati dati broj, a registar edi sumu
        ## njegovih "pravih" djelilaca, dok ce registar ecx biti
	## koriscen kao brojac.
        mov     ebx, [ebp+8]
        xor     edi, edi
        xor     ecx, ecx

next_number:
        ## Prelazi se na naredni potencijalni djelilac datog broja.
        inc     ecx

        ## Provjerava se da li je taj djelilac jednak datom broju i, ako
        ## jeste, zavrsava se sa petljom; ova provjera je neophodna da
	## bi se pokrio slucaj kada je dati broj jednak 1.
        cmp     ecx, ebx
        je done

        ## Provjerava se da li je kvadrat potencijalnog djelioca veci od
        ## datog broja, u kom slucaju se zavrsava sa petljom; radi
        ## efikasnosti, petlja je napravljena tako da se u iteracijama
	## ide samo do kvadratnog korijena datog broja.
        mov     eax, ecx
        mul     ecx
        cmp     eax, ebx
        ja done

        ## Dijeli se dati broj sa potencijalnim djeliocem.
        mov     eax, ebx
        xor     edx, edx
        div     ecx

        ## Ako je dati broj djeljiv sa potencijalnim djeliocem,
        ## zaracunava se djelilac u sumu djelilaca, a u suprotnom se
	## prelazi na narednu iteraciju.
        cmp     edx, 0
        jne continue
        add     edi, ecx

        ## Ako je dati broj djeljiv sa tekucim potencijalnim djeliocem,
        ## u sumu djelilaca se odmah moze zaracunati i kolicnik (jer je
        ## dati broj djeljiv i sa njime), osim ako potencijalni djelilac
        ## nije jednak 1 (u kom slucaju je kolicnik dati broj, koji sam
        ## sebi nije "pravi" djelilac), odn. ako potencijalni djelilac
        ## nije kvadratni korijen datog broja (u kom slucaju ga nije
	## potrebno zaracunavati dva puta u sumu).
        cmp     ecx, 1
        je continue
        cmp     eax, ecx
        je continue
        add     edi, eax
        
continue:
        ## Prelazi se na narednu iteraciju.
        jmp next_number

done:
        ## Rezultat izracunavanja se prebacuje u registar eax.
        mov     eax, edi        

        ## Epilog funkcije.
        pop     edi
        pop     ebx
        leave
        ret
