.intel_syntax noprefix

.data
g:      .float  9.8
pi_deg: .float  180

.text
.global projectile

	## Funkcija projectile() izracunava poziciju i brzinu projektila
        ## u datom trenutku za poznate parametre izbacaja.  Argumenti
	## funkcije su:
        ##   [ebp+8] - ugao (u stepenima) pod kojim je izbacen projektil
        ##   [ebp+12] - pocetna brzina projektila
        ##   [ebp+16] - vrijeme proteklo od izbacivanja projektila
        ##   [ebp+20] - adresa na koju treba upisati izracunatu
	##              horizontalnu koordinatu projektila u datom
	##              trenutku
        ##   [ebp+24] - adresa na koju treba upisati izracunatu
	##              vertikalnu koordinatu projektila u datom
	##              trenutku
        ##   [ebp+28] - adresa na koju treba upisati vrijednost brzine u
	##              datom trenutku
        ##   [ebp+32] - adresa na koju treba upisati ugao (u stepenima)
        ##              koji u datom trenutku zaklapa vektor brzine sa
	##              horizontalnom ravni
        ## Pretpostavka je da je dati ugao izbacaja broj u opsegu
        ## (0,90), te da su pocetna brzina projektila, i vrijeme
        ## proteklo od izbacivanja, brojevi veci od 0.  Funkcija se u
	## potpunosti podvrgava C konvencijama pozivanja.
projectile:
        ## Prolog funkcije.
        enter   0, 0
        push    ebx

        ## Izracunavaju se, i upisuju u za to predvidjene lokacije u
	## memoriji, trazene vrijednosti koje opisuju kretanje
	## projektila u datom trenutku.
        fld     dword ptr [pi_deg]      # Stek: 180
        fld     dword ptr [ebp+16]      # Stek: 180, t
        fld     dword ptr [g]           # Stek: 180, t, g
        fmul    st, st(1)               # Stek: 180, t, g*t
        fldpi                           # Stek: 180, t, g*t, pi
        fdiv    st, st(3)               # Stek: 180, t, g*t, pi/180
        fmul    dword ptr [ebp+8]       # Stek: 180, t, g*t, alpha*pi/180=A
        fsincos                         # Stek: 180, t, g*t, sin(A), cos(A)
        fld     dword ptr [ebp+12]      # Stek: 180, t, g*t, sin(A), cos(A), u
        fmul    st(2), st               # Stek: 180, t, g*t, u*sin(A), cos(A), u
        fmulp                           # Stek: 180, t, g*t, u*sin(A), u*cos(A)=vx
        fld     st(1)                   # Stek: 180, t, g*t, u*sin(A), vx, u*sin(A)
        fsub    st, st(3)               # Stek: 180, t, g*t, u*sin(A), vx, u*sin(A)-g*t=vy
        fxch    st(4)                   # Stek: 180, vy, g*t, u*sin(A), vx, t
        fmul    st(2), st               # Stek: 180, vy, g*t, u*sin(A)*t, vx, t
        fmul    st(3), st               # Stek: 180, vy, g*t^2, u*sin(A)*t, vx, t
        fmul    st, st(1)               # Stek: 180, vy, g*t^2, u*sin(A)*t, vx, vx*t=x
        mov     ebx, [ebp+20]
        fstp    dword ptr [ebx]         # Stek: 180, vy, g*t^2, u*sin(A)*t, vx
        fxch    st(2)                   # Stek: 180, vy, vx, u*sin(A)*t, g*t^2
        fld1                            # Stek: 180, vy, vx, u*sin(A)*t, g*t^2, 1
        fchs                            # Stek: 180, vy, vx, u*sin(A)*t, g*t^2, -1
        fxch                            # Stek: 180, vy, vx, u*sin(A)*t, -1, g*t^2
        fscale                          # Stek: 180, vy, vx, u*sin(A)*t, -1, g*t^2/2
        fsubp   st(2), st               # Stek: 180, vy, vx, u*sin(A)*t-g*t^2/2=y, -1
        ffree   st                      # Stek: 180, vy, vx, y, invalidna vrijednost
        fincstp                         # Stek: 180, vy, vx, y
        mov     ebx, [ebp+24]
        fstp    dword ptr [ebx]         # Stek: 180, vy, vx
        fld     st                      # Stek: 180, vy, vx, vx
        fmul    st, st                  # Stek: 180, vy, vx, vx*vx
        fld     st(2)                   # Stek: 180, vy, vx, vx*vx, vy
        fmul    st, st                  # Stek: 180, vy, vx, vx*vx, vy*vy
        faddp                           # Stek: 180, vy, vx, vx*vx+vy*vy
        fsqrt                           # Stek: 180, vy, vx, sqrt(vx*vx+vy*vy)=v
        mov     ebx, [ebp+28]
        fstp    dword ptr [ebx]         # Stek: 180, vy, vx
        fpatan                          # Stek: 180, arctg(vy/vx)=T
        fmulp                           # Stek: T*180
        fldpi                           # Stek: T*180, pi
        fdivp                           # Stek: T*180/pi=theta
        mov     ebx, [ebp+32]
        fstp    dword ptr [ebx]         # Stek:

	## Epilog funkcije.
        pop     ebx
	leave
        ret
